//-------------------------------------------------------------------------------------------------------
// NX CRGB
// RGB摜߂̃NX
// ǂݍ߂摜tH[}bg:bmp
// version 1.05
//-------------------------------------------------------------------------------------------------------
//#include "stdafx.h"
#include "CRGB.h"


// RXgN^iFCj
CRGB::CRGB(int w, int h)
{
	m_width = w;
	m_height = h;
	m_band = 3;
	m_bCnt = 24;
	m_nColors = 1 << m_bCnt;
	for(int i=0; i<256; i++){
		m_CIdx[i].rgbBlue = 0;
		m_CIdx[i].rgbGreen = 0;
		m_CIdx[i].rgbRed = 0;
		m_CIdx[i].rgbReserved = 0;
	}
	m_data = NULL;
	allocateArray();
}

// RXgN^iFCCohj
CRGB::CRGB(int w, int h, int b)
{
	m_width = w;
	m_height = h;
	m_band = b;
	m_bCnt = 8*b;
	m_nColors = 1 << m_bCnt;
	for(int i=0; i<256; i++){
		m_CIdx[i].rgbBlue = i;
		m_CIdx[i].rgbGreen = i;
		m_CIdx[i].rgbRed = i;
		m_CIdx[i].rgbReserved = 0;
	}
	m_data = NULL;
	allocateArray();
}

// RXgN^iFt@Cj
CRGB::CRGB(char *filename)
{
	m_width = 0;
	m_height = 0;
	m_band = 3;
	m_bCnt = 0;
	m_nColors = 0;
	for(int i=0; i<256; i++){
		m_CIdx[i].rgbBlue = 0;
		m_CIdx[i].rgbGreen = 0;
		m_CIdx[i].rgbRed = 0;
		m_CIdx[i].rgbReserved = 0;
	}
	m_data = NULL;
	readImage(filename);
}

// Rs[RXgN^
CRGB::CRGB(const CRGB &img1)
{
	// img1̍sA񐔂Aimg1Ɠ傫̗̈m
	m_width = img1.m_width;
	m_height = img1.m_height;
	m_band = img1.m_band;
	m_bCnt = img1.m_bCnt;
	m_nColors = img1.m_nColors;

	for(int i=0; i<256; i++){
		m_CIdx[i].rgbBlue = img1.m_CIdx[i].rgbBlue;
		m_CIdx[i].rgbGreen = img1.m_CIdx[i].rgbGreen;
		m_CIdx[i].rgbRed = img1.m_CIdx[i].rgbRed;
		m_CIdx[i].rgbReserved = img1.m_CIdx[i].rgbReserved;
	}

	m_data = NULL;
	allocateArray();

	// img1̗vf
	for(int i=0; i<m_height; i++){
		for(int j=0; j<m_width; j++){
			for(int k=0; k<m_band; k++){
				m_data[i*m_width*m_band + j*m_band + k] = img1.m_data[i*m_width*m_band + j*m_band + k];
			}
		}
	}
}

// fXgN^
CRGB::~CRGB(void)
{
	freeArray();
}


// RGB摜ǂݍ݁igp\ȊgqFbmpj
void CRGB::readImage(char *filename)
{
	// gqo
	char *ext;
	ext = strrchr(filename,'.') + sizeof(char);

	// ogqt@C̎ނ𔻕
	int f_mode;
	if(stricmp(ext, "bmp") == 0){
		f_mode = BMP_MODE;
	}
	else{
		cerr << "gq" << ext << " ǂݍނƂ͂ł܂ @(CRGB::readImage)" << endl;
		getchar();
		exit(1);
	}

	// 摜t@CJ
	FILE *fp;
	if ((fp = fopen(filename, "rb"))==NULL) {
		cerr << filename << " JƂł܂ @(CRGB::readImage)" << endl;
		getchar();
		exit(1);
	}

	cout << "input file : " << filename << endl;

	// wb_ꍇ́Awb_摜o
	switch(f_mode){
		case BMP_MODE:
			read_bmp(fp);
			break;

		default:
			cerr << "\ȂG[ł @(CRGB::readImage)" << endl;
			getchar();
			exit(1);
	}

	fclose(fp);

	printImageInfo();
}

// RGB摜݁igp\ȊgqFbmpj
void CRGB::writeImage(char *filename)
{
	// gqo
	char *ext;
	ext = strrchr(filename,'.') + sizeof(char);

	// ogqt@C̎ނ𔻕
	int f_mode;

	if(stricmp(ext, "bmp") == 0){
		f_mode = BMP_MODE;
	}
	else{
		cerr << "gq" << ext << " ɏނƂ͂ł܂ @(CRGB::writeImage)" << endl;
		getchar();
		exit(1);
	}

	// 摜t@CJ
	FILE *fp;
	if ((fp = fopen(filename, "wb"))==NULL) {
		cerr << filename << " JƂł܂ @(CRGB::writeImage)" << endl;
		getchar();
		exit(1);
	}

	cout << "output file : " << filename << endl << endl;

	switch(f_mode){
		case BMP_MODE:
			write_bmp(fp);
			break;

		default:
			cerr << "\ȂG[ł @(CRGB::writeImage)" << endl;
			getchar();
			exit(1);
	}

	fclose(fp);
}

// oh̃qXgOo
void CRGB::writeHist(char *filename, int b)
{
	int hist[256]={0};

	for(int i=0; i<m_height; i++){
		for(int j=0; j<m_width; j++){
			hist[ m_data[i*m_width*m_band + j*m_band + b] ]++;
		}
	}

	// t@CJ
	FILE *fp;
	if ((fp = fopen(filename, "w"))==NULL) {
		cerr << filename << " JƂł܂ @(CRGB::writeHist)" << endl;
		getchar();
		exit(1);
	}

	cout << "output file : " << filename << endl << endl;

	for(int i=0; i<256; i++){
		if(hist[i] != 0){
			fprintf(fp, "%d\t%d\n", i, hist[i]);
		}
	}

	fclose(fp);
}

// Poh̉摜쐬
CRGB& CRGB::getMonoBand(const CRGB &img_in, int b)
{
	// 摜̕Ał邩𔻒
	if((m_width != img_in.m_width) || (m_height != img_in.m_height)){
		cerr << "摜TCYقȂ܂ (" << m_width << " , " << m_height << ")+("
			<< img_in.m_width << " , " << img_in.m_height << ") @(CRGB::getMonoBand)" << endl;
	}

	else{
		for(int i=0; i<m_height; i++){
			for(int j=0; j<m_width; j++){
				for(int k=0; k<m_band; k++){
					m_data[i*m_width*m_band + j*m_band + k]= img_in.m_data[i*m_width*img_in.m_band + j*img_in.m_band + b];
				}
			}
		}
	}

	return *this;
}

// f(w,h)boh̐Ml擾
unsigned char CRGB::getSig(int w, int h, int b)
{
	// w肳ꂽfA摜̕AAoh͈͓̔ł邩𔻒
	if((w >= m_width) || (h >= m_height) || (b >= m_band)){
		cerr << "w肳ꂽf݂܂ @(CRGB::getSig)" << endl;
	}

	return m_data[h*m_width*m_band + w*m_band + b];
}

// f(w,h)bohɐMlݒ
void CRGB::setSig(int w, int h, int b, unsigned char sig)
{
	// w肳ꂽfA摜̕AAoh͈͓̔ł邩𔻒
	if((w >= m_width) || (h >= m_height) || (b >= m_band)){
		cerr << "w肳ꂽf݂܂ @(CRGB::setSig)" << endl;
	}

	m_data[h*m_width*m_band + w*m_band + b] = sig;
}

// oh̍ő̐Ml擾
unsigned char CRGB::getMaxSig(int b)
{
	unsigned char max = 0;

	for(int i=0; i<m_height; i++){
		for(int j=0; j<m_width; j++){
			if(max < m_data[i*m_width*m_band + j*m_band + b]){
				max = m_data[i*m_width*m_band + j*m_band + b];
			}
		}
	}

	return max;
}

// oh̍ŏ̐Ml擾
unsigned char CRGB::getMinSig(int b)
{
	unsigned char min = 255;

	for(int i=0; i<m_height; i++){
		for(int j=0; j<m_width; j++){
			if(min > m_data[i*m_width*m_band + j*m_band + b]){
				min = m_data[i*m_width*m_band + j*m_band + b];
			}
		}
	}

	return min;
}

// oh̐Ml̑a擾
unsigned long CRGB::getSumSig(int b)
{
	unsigned long sum = 0;

	for(int i=0; i<m_height; i++){
		for(int j=0; j<m_width; j++){
			sum += m_data[i*m_width*m_band + j*m_band + b];
		}
	}

	return sum;
}

// oh̐Ml̕ς擾
double CRGB::getAveSig(int b)
{
	double ave;

	ave = (double)getSumSig(b) / (double)(m_width * m_height); 

	return ave;
}

// oh̐Ml̕U擾
double CRGB::getSDSig(int b)
{
	double sd = 0.0;
	double ave = getAveSig(b);

	for(int i=0; i<m_height; i++){
		for(int j=0; j<m_width; j++){
			sd += ((double)m_data[i*m_width*m_band + j*m_band + b] - ave) * ((double)m_data[i*m_width*m_band + j*m_band + b] - ave);
		}
	}

	sd /= (double)(m_width * m_height);

	return sd;
}

// 摜̕AAohĐݒ
void CRGB::resetMemberVariable(int w, int h, int b)
{
	m_width = w;
	m_height = h;
	m_band = b;

	allocateArray();
}

// 摜̕AAoh\
void CRGB::printImageInfo(void)
{
	cout << "width : " << m_width << "\t";
	cout << "height : " << m_height << "\t";
	cout << "band : " << m_band << endl ;
}

// tB^
void CRGB::smoothing(void)
{
	int val;

	for(int i=1; i<m_height-1; i++){
		for(int j=1; j<m_width-1; j++){
			for(int k=0; k<m_band; k++){
				val = m_data[(i-1)*m_width*m_band + (j-1)*m_band + k] + m_data[(i-1)*m_width*m_band + j*m_band + k] + m_data[(i-1)*m_width*m_band + (j+1)*m_band + k]
				+ m_data[i*m_width*m_band + (j-1)*m_band + k] + m_data[i*m_width*m_band + j*m_band + k] + m_data[i*m_width*m_band + (j+1)*m_band + k]
				+ m_data[(i+1)*m_width*m_band + (j-1)*m_band + k] + m_data[(i+1)*m_width*m_band + j*m_band + k] + m_data[(i+1)*m_width*m_band + (j+1)*m_band + k];

				val /= 9;
				m_data[i*m_width*m_band + j*m_band + k] = (unsigned char)val;
			}
		}
	}
}

// F𔽓]
void CRGB::reverseColor(void)
{
	for(int i=0; i<m_height; i++){
		for(int j=0; j<m_width; j++){
			for(int k=0; k<m_band; k++){
				m_data[i*m_width*m_band + j*m_band + k] = 255 - m_data[i*m_width*m_band + j*m_band + k];
			}
		}
	}
}


// ̈̊m
void CRGB::allocateArray(void)
{
	if(m_data != NULL){
		freeArray();
	}
	if(m_width <= 0 || m_height <= 0 || m_band <= 0){
		m_data = NULL;
		return;
	}
	m_data = new unsigned char [m_width * m_height * m_band];
}

// ̈̊J
void CRGB::freeArray(void)
{
	delete [] m_data;
}

// BMP`ǂݍ
void CRGB::read_bmp(FILE *fp)
{
	BITMAPFILEHEADER	bmfh;
	BITMAPINFOHEADER	bmih;
	
	// t@Cwb_Ǎ
    read_bmfh(&bmfh, fp);

    // rbg}bv̓ǂݍ
    read_bmih(&bmih, fp);
	
	if((bmih.biWidth%4) != 0){
		cerr << "Width = "<<bmih.biWidth<<" 4̔{Ŗ̂œǂݍ߂Ȃ @(CRGB::read_bmp)" << endl;
		getchar();
		exit(1);
	}

	// pbgf[^̓ǂݍ

	// i[pbg0łȂꍇAKi[Ă
	if(bmih.biClrUsed != 0){
		m_nColors = bmih.biClrUsed;
	}
	// 0̏ꍇAFrbgZo
	else{
		m_nColors = 1 << bmih.biBitCount;
	}
	m_bCnt = bmih.biBitCount;

	// pbgCfbNX[1,4,8,16 bit]̃rbg}bv̏ꍇ
	if(bmih.biBitCount < 24){
		for(int i=0; i<m_nColors; i++){
			fread(&m_CIdx[i], sizeof(RGBQUAD), 1, fp);
		}
	}
	// tJ[[24/32 bit]rbg}bv̏ꍇɂ̓pbgf[^Ȃ
	
	unsigned int Line;		// 1C̃f[^
	unsigned int SizeImage;	// 摜f[^TCY
	
	// 1C̃f[^: 4byte Eɂ킹
	Line = (bmih.biWidth * bmih.biBitCount)/8;
	if((Line%4) != 0){
		Line = ((Line/4)+1)*4;
	}
	SizeImage=(Line*bmih.biHeight);

	m_width = bmih.biWidth;
	m_height = bmih.biHeight;
	m_band = bmih.biBitCount / 8;
	if(m_band == 0){
		m_band = 1;
	}
	
	// ̈m
	allocateArray();

	unsigned int nRead = (unsigned int)fread(m_data, sizeof(BYTE), SizeImage, fp);
    if(nRead != SizeImage){
		cerr << "t@Cǂݍ݃G[ @(CRGB::read_bmp)" << endl;
		getchar();
		exit(1);
	}

	convData(0);
	reverseBandData();
}

// t@Cwb_ǂݍ
void CRGB::read_bmfh(BITMAPFILEHEADER *bmfh, FILE *fp)
{
    fread(&bmfh->bfType, sizeof(WORD), 1, fp);
    fread(&bmfh->bfSize, sizeof(DWORD), 1, fp);
    fread(&bmfh->bfReserved1, sizeof(WORD), 1, fp);
    fread(&bmfh->bfReserved2, sizeof(WORD), 1, fp);
    fread(&bmfh->bfOffBits, sizeof(DWORD), 1, fp);
#ifdef LS_BMPHEADER
	disp_bmfh(*bmfh);
#endif
}

// wb_ǂݍ
void CRGB::read_bmih(BITMAPINFOHEADER *bmih, FILE *fp)
{
    fread(&bmih->biSize,sizeof(DWORD),1,fp);

	// WindowsOS/2̔
	// Windows
	if(bmih->biSize == 40){
		fread(&bmih->biWidth,sizeof(LONG),1,fp);
		fread(&bmih->biHeight,sizeof(LONG),1,fp);
		fread(&bmih->biPlanes,sizeof(WORD),1,fp);
		fread(&bmih->biBitCount,sizeof(WORD),1,fp);
		fread(&bmih->biCompression,sizeof(DWORD),1,fp);
		fread(&bmih->biSizeImage,sizeof(DWORD),1,fp);
		fread(&bmih->biXPelsPerMeter,sizeof(LONG),1,fp);
		fread(&bmih->biYPelsPerMeter,sizeof(LONG),1,fp);
		fread(&bmih->biClrUsed,sizeof(DWORD),1,fp);
		fread(&bmih->biClrImportant,sizeof(DWORD),1,fp);
	}
	// OS/2
	else if(bmih->biSize == 12){
		fread(&bmih->biWidth,sizeof(short),1,fp);
		fread(&bmih->biHeight,sizeof(short),1,fp);
		fread(&bmih->biPlanes,sizeof(WORD),1,fp);
		fread(&bmih->biBitCount,sizeof(WORD),1,fp);
	}
	else{
		cerr << "z肳ĂȂP[Xł @(CRGB::read_bmp)" << endl;
		getchar();
		exit(1);
	}
#ifdef LS_BMPHEADER
	disp_bmih(*bmih);
#endif
}

// BMP`
void CRGB::write_bmp(FILE *fp)
{
	// t@Cwb_
    write_bmfh(fp);

	// wb_
	write_bmih(fp);

	// pbgf[^
	if(m_bCnt < 24){
		for(int i=0; i<m_nColors; i++){
			fwrite(&m_CIdx[i], sizeof(RGBQUAD), 1, fp);
		}
	}

	// t@Cwb_(14 Byte) + wb_TCY(40 Byte) + pbg
	long count = ftell(fp);
	long pal_n = (m_bCnt >= 24) ? 0 : 256;
	if(count != 54 + sizeof(RGBQUAD) * pal_n){
		cerr << "t@C݃G[ @(CRGB::write_bmp)" << endl;
		getchar();
		exit(1);
	}

	// 摜f[^בւ
	reverseBandData();
	convData(0);

	// 摜f[^
	int		Line = (m_width * m_bCnt) / 8;
	DWORD	size;

	if((Line%4) != 0){
		Line = ((Line/4)+1)*4;
	}
	size = Line * m_height;

	fwrite(m_data, sizeof(BYTE), size, fp);

	// 摜f[^בւ
	convData(0);
	reverseBandData();
}

// t@Cwb_
void CRGB::write_bmfh(FILE *fp)
{
	// ʕ BM
	char s[2];
	s[0] = 'B';
	s[1] = 'M';
	fwrite(s, sizeof(char), 2,fp);

	// t@CTCY bfSize
	// 摜f[^܂ł̃ItZbg(wb_TCY)
	WORD	pal_n  = (m_bCnt >= 24) ? 0 : 256;
	DWORD	offset = 14 + 40 + pal_n*sizeof(RGBQUAD);
	int		Line = (m_width * m_bCnt) / 8;
	DWORD	size;

	if((Line%4) != 0){
		Line = ((Line/4)+1)*4;
	}
	size = Line * m_height;
	size += offset;
	fwrite(&size, sizeof(DWORD), 1, fp);

	// \GA bfReserved1 
	WORD reserved = 0;
	fwrite(&reserved, sizeof(WORD), 1, fp);

	// \GA bfReserved2 
	fwrite(&reserved, sizeof(WORD), 1, fp);

	// f[^܂ł̃ItZbg bfOffBits 
	fwrite(&offset, sizeof(DWORD), 1, fp);
}

// wb_
void CRGB::write_bmih(FILE *fp){

	long	var_l;
	short	var_s;

	// wb_TCY biSize (Windows BMP  40) 
	var_l = 40;
	fwrite(&var_l, sizeof(long), 1, fp);

	// 摜̕ biWidth
	var_l = m_width;
	fwrite(&var_l, sizeof(long), 1, fp);

	// 摜̍ biHeight 
	// (Ȃ΍E, }CiXȂ΍ォE) 
	var_l = m_height;
	fwrite(&var_l, sizeof(long), 1, fp);

	// v[ biPlanes (K 1) 
	var_s = 1;
	fwrite(&var_s, sizeof(short), 1, fp);

	// 1sNZ̃f[^ biBitCount (1, 4, 8, 24, 32)
	var_s = m_bCnt;
	fwrite(&var_s, sizeof(short), 1, fp);

	// k biCompression (kȂ 0) 
	var_l = 0;
	fwrite(&var_l, sizeof(long), 1, fp);

	// 摜̃TCY biSizeImage 
	int	Line = (m_width * m_bCnt) / 8;
	if((Line % 4) != 0){
		Line = ((Line / 4) + 1) * 4;
	}
	var_l = Line * m_height;
	fwrite(&var_l, sizeof(long), 1, fp);

	// 𑜓x pixel/m biXPelPerMeter 
	// (96dpi, 1inch = 0.0254m ̂Ƃ 96/0.0254 = 3780) 
	var_l = 0;
	fwrite(&var_l, sizeof(long), 1, fp);

	// c𑜓x pixel/m biYPelPerMeter 
	// (96dpi, 1inch = 0.0254m ̂Ƃ 96/0.0254 = 3780) 
	var_l = 0;
	fwrite(&var_l, sizeof(long), 1, fp);

	// pbg biClrUsed: 1 << bi.bCnt;
	if(m_bCnt >= 24){
		var_l = 0;
		fwrite(&var_l, sizeof(long), 1, fp);
	}
	else{
		var_l = m_nColors;
		fwrite(&var_l, sizeof(long), 1, fp);
	}

	// pbg̏dvȐF  biClrImportant 
	var_l = 0;
	fwrite(&var_l, sizeof(long), 1, fp);
}

// t@Cwb_̕\
void CRGB::disp_bmfh(BITMAPFILEHEADER bmfh)
{
	cout << "[bitmap file header]" << endl;
	cout << "         bfType = " << bmfh.bfType << endl;
	cout << "         bfSize = " << bmfh.bfSize/1024 << "[KByte]" << endl;
	cout << "    bfReserved1 = " << bmfh.bfReserved1 << endl;
	cout << "    bfReserved2 = " << bmfh.bfReserved2 << endl;
	cout << "      bfOffBits = " << bmfh.bfOffBits << endl << endl;
}

// wb_\
void CRGB::disp_bmih(BITMAPINFOHEADER bmih)
{
	cout << "[bitmap info header]" << endl;
	cout << "         biSize = " << bmih.biSize << "[Byte]" << endl;

	// Windows
	if(bmih.biSize == 40){
		cout << "        biWidth = " << bmih.biWidth << endl;
		cout << "       biHeight = " << bmih.biHeight << endl;
		cout << "       biPlanes = " << bmih.biPlanes << endl;
		cout << "     biBitCount = " << bmih.biBitCount << endl;
		cout << "  biCompression = " << bmih.biCompression << endl;
		cout << "    biSizeImage = " << bmih.biSizeImage << endl;
		cout << "biXPelsPerMeter = " << bmih.biXPelsPerMeter << endl;
		cout << "biYPelsPerMeter = " << bmih.biYPelsPerMeter << endl;
		cout << "      biClrUsed = " << bmih.biClrUsed << endl;
		cout << " biClrImportant = " << bmih.biClrImportant << endl << endl;
	}
	
	// OS/2
	else if(bmih.biSize == 12){
		cout << "        biWidth = " << (short)bmih.biWidth << endl;
		cout << "       biHeight = " << (short)bmih.biHeight << endl;
		cout << "       biPlanes = " << bmih.biPlanes << endl;
		cout << "     biBitCount = " << bmih.biBitCount << endl;
	}
}

// 摜f[^_A㌴_ɕבւ
void CRGB::convData(int mem)
{
	CRGB img = *this;

	//	 ɓ_A㌴_ŕłΏI
	if(m_width > 0 && m_height < 0 && mem == 0){
		/*cout << "_A㌴_" << endl;*/
		m_height = -m_height;
	}

	else if(m_width > 0 && m_height > 0 && mem == 0){
		for(int i=0; i<m_height; i++){
			for(int j=0; j<m_width; j++){
				for(int k=0; k<m_band; k++){
					m_data[(m_height-i-1)*m_width*m_band + j*m_band + k] = img.m_data[i*img.m_width*img.m_band + j*img.m_band + k];
				}
			}
		}
		/*cout << "_A_" << endl;*/
	}

	//	 ȊǑ`̉摜͌ƂȂ̂ŏȗ
	else{
		cerr << "z肳ĂȂP[Xł @(CRGB::convData)" << endl;
		getchar();
		exit(1);
	}
}

// eoh̒ltɓւiBMP̎dl̂߂̊֐j
void CRGB::reverseBandData(void)
{
	CRGB img = *this;

	for(int i=0; i<m_height; i++){
		for(int j=0; j<m_width; j++){
			for(int k=0; k<m_band; k++){
				m_data[i*m_width*m_band + j*m_band + m_band-k-1] = img.m_data[i*img.m_width*img.m_band + j*img.m_band + k];
			}
		}
	}
}
