#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>

#include "memory_allocate.h"
#include "MSI.h"
#include "svd_v2.h"
#include "TABLE.h"
#include "SPECT.h"
#include "NaturalVision.h"

#pragma warning(disable:4996)
#define _CRT_SECURE_NO_DEPRECATE 1

double *wieCOV(char *fn_Tra,int INTERVAL,int START,int END)//OɊÂč쐬֍s
{
	Spec Tra;
	double *Cov;
	int i,j,k;
	
	Tra=SpecGet(fn_Tra);
	Cov=dvector(0,Tra.WL*Tra.WL);
	
	for(i=START;i<END;i+=INTERVAL){
		for(j=START;j<END;j+=INTERVAL){
			Cov[i*Tra.WL+j]=0;
			for(k=0;k<Tra.Num;k++){
				Cov[i*Tra.WL+j]+=Tra.data[i*Tra.Num+k]*Tra.data[j*Tra.Num+k];
			}
		}
	}
	
	for(i=START;i<END;i+=INTERVAL){
		for(j=START;j<END;j+=INTERVAL){
			Cov[i*Tra.WL+j]/=Tra.Num;
		}
	}
	
	free_dvector(Tra.data,0,(Tra.WL)*(Tra.Num));
	
	return Cov;
	
}

double *wieMCOV(double Prob,int WL,int INTERVAL,int START,int END)//marcov֍s̍쐬
{
	double *Cov;
	int i,j,k;
	

	Cov=dvector(0,WL*WL);

	for(i=START;i<END;i+=INTERVAL){
		for(j=START;j<END;j+=INTERVAL){
			Cov[i*WL+j]=1;
		}
	}

	for(i=START;i<END;i+=INTERVAL){
		for(j=START;j<END;j+=INTERVAL){
			if(fabs((double)(j-i))>=1){
				for(k=1;k<=fabs((double)(j-i));k++){
					Cov[i*WL+j]*=Prob;//Prob̓}Rt֍s̑Jڊm
				}
			}
		}
	}
	
	return Cov;
	
}

double *SysMat(Wie *Wmat,Spec *Fil,Spec *CCD,Spec *iIll,MSI *wSig)
{
	int i,j;
	double *cal_g,*tr_H;

	cal_g=dvector(0,wSig->BAND);
	tr_H=dvector(0,Wmat->BAND*Wmat->WL);

	for(j=0;j<Wmat->BAND;j++){ //tr_H = WL * BAND
		for(i=Wmat->START;i<Wmat->END;i+=Wmat->INTERVAL){
			tr_H[i*Wmat->BAND+j]=Fil->data[i*Wmat->BAND+j]*CCD->data[i]*iIll->data[i];
		}
	}
	
	
	for(j=0;j<Wmat->BAND;j++){ //cal_g is calculated signal  
		cal_g[j]=0;
		for(i=Wmat->START;i<Wmat->END;i+=Wmat->INTERVAL){
			cal_g[j]+=tr_H[i*Wmat->BAND+j]*1;
		}
	}
	
	for(i=Wmat->START;i<Wmat->END;i+=Wmat->INTERVAL){// corrected SYSTEM MATRIX
		for(j=0;j<Wmat->BAND;j++){ //tr_H = WL * BAND
			tr_H[i*Wmat->BAND+j]*=wSig->data[j]/cal_g[j];
		}
	}

	free_dvector(cal_g,0,wSig->BAND);

	return tr_H;


}

double *WienerMat(Wie *Wmat,MSI *wSig)
{
	double *A,*B,*invB,*n,*mat;
	int i,j,k;

	A=dvector(0,Wmat->WL*Wmat->BAND);
	B=dvector(0,Wmat->BAND*Wmat->BAND);
	invB=dvector(0,Wmat->BAND*Wmat->BAND);
	n=dvector(0,Wmat->BAND);
	mat=dvector(0,Wmat->WL*Wmat->BAND);

	for(j=0;j<Wmat->BAND;j++){ //tr_H = WL * BAND
		n[j]=wSig->data[j]*Wmat->NLEVEL;
	}
	
	for(i=Wmat->START;i<Wmat->END;i+=Wmat->INTERVAL){
		for(j=0;j<Wmat->BAND;j++){
			A[i*Wmat->BAND+j]=0;//A = WL * BAND = Cov(WL*WL)*tr_H(WL*BAND)
			for(k=Wmat->START;k<Wmat->END;k+=Wmat->INTERVAL){
				A[i*Wmat->BAND+j]+=Wmat->Cov[i*Wmat->WL+k]*Wmat->tr_H[k*Wmat->BAND+j];
			}
		}
	}
	
	for(i=0;i<Wmat->BAND;i++){
		for(j=0;j<Wmat->BAND;j++){
			B[i*Wmat->BAND+j]=0;//B = BAND * BAND = trnspose(tr_H(WL*BAND))*A(WL*BAND)
			for(k=Wmat->START;k<Wmat->END;k+=Wmat->INTERVAL){
				B[i*Wmat->BAND+j]+=Wmat->tr_H[k*Wmat->BAND+i]*A[k*Wmat->BAND+j];
			}
		}
	}
	
	for(i=0;i<Wmat->BAND;i++){
		B[i*Wmat->BAND+i]+=n[i]*n[i];//add noise	
	}
	
	svdinv_zeromat1D(B,invB,Wmat->BAND,Wmat->BAND);
	
	for(i=Wmat->START;i<Wmat->END;i+=Wmat->INTERVAL){
		for(j=0;j<Wmat->BAND;j++){
			mat[i*Wmat->BAND+j]=0;//Wmat = WL * BAND = A(WL*BAND)*invB(BAND*BAND)
			for(k=0;k<Wmat->BAND;k++){
				mat[i*Wmat->BAND+j]+=A[i*Wmat->BAND+k]*invB[k*Wmat->BAND+j];
			}
		}
	}

	free_dvector(A,0,Wmat->WL*Wmat->BAND);
	free_dvector(B,0,Wmat->BAND*Wmat->BAND);
	free_dvector(invB,0,Wmat->BAND*Wmat->BAND);
	free_dvector(n,0,Wmat->BAND);

	return mat;

}

double *WienerMat(Wie *Wmat,double *wSig)
{
	double *A,*B,*invB,*n,*mat;
	int i,j,k;

	A=dvector(0,Wmat->WL*Wmat->BAND);
	B=dvector(0,Wmat->BAND*Wmat->BAND);
	invB=dvector(0,Wmat->BAND*Wmat->BAND);
	n=dvector(0,Wmat->BAND);
	mat=dvector(0,Wmat->WL*Wmat->BAND);

	for(j=0;j<Wmat->BAND;j++){ //tr_H = WL * BAND
		n[j]=wSig[j]*Wmat->NLEVEL;
	}
	
	for(i=Wmat->START;i<Wmat->END;i+=Wmat->INTERVAL){
		for(j=0;j<Wmat->BAND;j++){
			A[i*Wmat->BAND+j]=0;//A = WL * BAND = Cov(WL*WL)*tr_H(WL*BAND)
			for(k=Wmat->START;k<Wmat->END;k+=Wmat->INTERVAL){
				A[i*Wmat->BAND+j]+=Wmat->Cov[i*Wmat->WL+k]*Wmat->tr_H[k*Wmat->BAND+j];
			}
		}
	}
	
	for(i=0;i<Wmat->BAND;i++){
		for(j=0;j<Wmat->BAND;j++){
			B[i*Wmat->BAND+j]=0;//B = BAND * BAND = trnspose(tr_H(WL*BAND))*A(WL*BAND)
			for(k=Wmat->START;k<Wmat->END;k+=Wmat->INTERVAL){
				B[i*Wmat->BAND+j]+=Wmat->tr_H[k*Wmat->BAND+i]*A[k*Wmat->BAND+j];
			}
		}
	}
	
	for(i=0;i<Wmat->BAND;i++){
		B[i*Wmat->BAND+i]+=n[i]*n[i];//add noise	
	}
	
	svdinv_zeromat1D(B,invB,Wmat->BAND,Wmat->BAND);
	
	for(i=Wmat->START;i<Wmat->END;i+=Wmat->INTERVAL){
		for(j=0;j<Wmat->BAND;j++){
			mat[i*Wmat->BAND+j]=0;//Wmat = WL * BAND = A(WL*BAND)*invB(BAND*BAND)
			for(k=0;k<Wmat->BAND;k++){
				mat[i*Wmat->BAND+j]+=A[i*Wmat->BAND+k]*invB[k*Wmat->BAND+j];
			}
		}
	}

	free_dvector(A,0,Wmat->WL*Wmat->BAND);
	free_dvector(B,0,Wmat->BAND*Wmat->BAND);
	free_dvector(invB,0,Wmat->BAND*Wmat->BAND);
	free_dvector(n,0,Wmat->BAND);

	return mat;

}

Wie Do_Wmat(char *fn_sys, char *fn_wSig)
{
	FILE *fp;
	char temp[200];

	Wie wimat;
	MSI wSig;//Multi Spectral Image of white 
	char fn_Tra[100];//Mesured Transmittance is Priori Information
	Spec iIll;// Input Radiance of illumination
	Spec CCD;//Sensitivity of CCD Camera
	Spec Fil;//Spectral Transmittance of N BAND Fillters

	wSig.fn=fn_wSig;

	if((fp=fopen(fn_sys,"r"))==NULL){
		printf("%s file open error!!\n",fn_sys);
		getchar();
		exit(1);
	}
	fscanf(fp,"%s",temp);// hPrioriInformationh@ǂݔ΂
	fscanf(fp,"%s",fn_Tra);
	fscanf(fp,"%s",temp);// hinputIlluminationh@ǂݔ΂
	fscanf(fp,"%s",iIll.fn);
	fscanf(fp,"%s",temp);// hCCDSnsitivityh@ǂݔ΂
	fscanf(fp,"%s",CCD.fn);
	fscanf(fp,"%s",temp);// hFilterh@ǂݔ΂
	fscanf(fp,"%s",Fil.fn);

	fclose(fp);

	wSig=MSI_wSig(wSig.fn);//Ml̒o
	iIll=SpecGet(iIll.fn);//ˌXyNgi[
	CCD=SpecGet(CCD.fn);//CCDxi[
	Fil=SpecGet(Fil.fn);//̃tB^[ߗi[

	//iIll CCD Fil ̔g`FbNvO쐬
	

	wimat.BAND=Fil.Num;
	wimat.WL=Fil.WL;
	wimat.INTERVAL=iniINTERVAL;// sampling interval********************************************
	wimat.NLEVEL=iniNLEVEL;//Noise Level*************************************************

	if(wimat.BAND!=wSig.BAND){
		printf("%s is not system matrix for \n%s!!\n",fn_sys,wSig.fn);
		getchar();
		exit(1);
	}
	
	if(iniSTART<=iIll.START){
		wimat.START=0;
	}else{
		wimat.START=iniSTART-iIll.START;
	}
	if(iniEND>=iIll.END){
		wimat.END=iIll.END-iIll.START+1;
	}else{
		wimat.END=iniEND-iIll.START+1;//REVISE 2007/04/11
		if(wimat.END>401){
			printf("%s file is over wavelength dimension!!\n",iIll.fn);
		}
	}
	
	if(SELCOV){
		printf("Wiener matrix is used covariance obtained by priori information.\n");
		wimat.Cov=wieCOV(fn_Tra,wimat.INTERVAL,wimat.START,wimat.END);//Us̎Zo
	}else{
		printf("Wiener matrix is used covariance obtained by marcov chain.\n");
		wimat.Cov=wieMCOV(iniProb,wimat.WL,wimat.INTERVAL,wimat.START,wimat.END);//Us̎Zo
	}
	
	wimat.tr_H=SysMat(&wimat,&Fil,&CCD,&iIll,&wSig);//VXesvZ
	wimat.mat=WienerMat(&wimat,&wSig);//wienersvZ

	free_dvector(Fil.data,0,Fil.WL*Fil.Num);
	free_dvector(CCD.data,0,CCD.WL*CCD.Num);
	free_dvector(iIll.data,0,iIll.WL*iIll.Num);

	return wimat;

}

Spec	xyzSpecGet(char *fn_xyz,char *fn_oIll,int START,int END,int INTERVAL)
{
	Spec	xyzfunc;//F֐
	Spec	oIll;//ώ@̏ƖXyNg
	int iniY=100;
	int	Y=1;
	double cY;//␳W
	double valY;//Y̎hl
	int i,k;

	xyzfunc=SpecGet(fn_xyz);
	oIll=SpecGet(fn_oIll);//ώ@̓ˌXyNgi[
		
	valY=0;
	for(i=START;i<END;i+=INTERVAL){
		valY+=xyzfunc.data[i*xyzfunc.Num+Y]*oIll.data[i];
	}
	cY=iniY/valY;
	for(k=0;k<xyzfunc.Num;k++){//xyzF֐̕␳ Ɩ̃XyNgZ
			for(i=START;i<END;i+=INTERVAL){
				xyzfunc.data[i*xyzfunc.Num+k]*=cY*oIll.data[i];
			}
	}

	free_dvector(oIll.data,0,oIll.WL);

	return xyzfunc;

}

Disp DispGet(char *fn_prima,Spec xyzfunc,int START,int END,int INTERVAL)
{
	int iniY=100;
	int	Y=1;
	double cY;//␳W
	double valY;//Y̎hl
	int i,j,k;

	Disp	dsp;
	dsp.primary=SpecGet(fn_prima);
	
	dsp.DtoX=dvector(0,xyzfunc.Num*xyzfunc.Num);
	dsp.XtoD=dvector(0,xyzfunc.Num*xyzfunc.Num);
	dsp.back=dvector(0,xyzfunc.Num);


	for(k=0;k<xyzfunc.Num;k++){//Disp to XYZ s̍쐬@Ɓ@wiXYZhl쐬
		for(j=0;j<xyzfunc.Num;j++){
			dsp.DtoX[k*xyzfunc.Num+j]=0;
			for(i=START;i<END;i+=INTERVAL){
				dsp.DtoX[k*xyzfunc.Num+j]+=xyzfunc.data[i*xyzfunc.Num+k]*dsp.primary.data[i*dsp.primary.Num+j];
			}
		}
		dsp.back[k]=0;
		for(i=START;i<END;i+=INTERVAL){
			dsp.back[k]+=xyzfunc.data[i*xyzfunc.Num+k]*dsp.primary.data[i*dsp.primary.Num+j];
		}
	}

	valY=0;
	for(i=0;i<xyzfunc.Num;i++){
		valY+=dsp.DtoX[Y*xyzfunc.Num+i];
	}

	valY-=dsp.back[Y];
	cY=iniY/valY;
	for(k=0;k<xyzfunc.Num;k++){//FMlXYZϊs̕␳
		dsp.back[k]*=cY;
		for(j=0;j<xyzfunc.Num;j++){
			dsp.DtoX[k*xyzfunc.Num+j]*=cY;
		}
	}
	
	//from XYZ to Disp 쐬
	svdinv_zeromat1D(dsp.DtoX,dsp.XtoD,xyzfunc.Num,xyzfunc.Num);

	return dsp;


}

Tone DispTone256(char *fn_tone,char *fn_step,int para){// Make Table (input rgb signal -> luminance of rgb spectral)
//	para=4;//ߎ̕ϐ̐ a1,a2,a3@ؕ(a0)܂߂ȂƂ̐
//͐Mlo͋Pxl̃e[u@ߎgpĊK256̃e[u쐬

	char fn_w[200];
	int i,j,k;
	int mstp=256;
	int stp,drgb,dim;
	double *ip_sig,*tone;//,*tone256;
	double *mat,*inv,*mat256,*w;

	Tone tone256;

	ReName(fn_tone,fn_w,"_256.spec");


	ip_sig=DataGet(fn_tone,&stp,&drgb);
	tone=DataGet(fn_step,&stp,&dim);
	tone256.data=dvector(0,mstp*drgb);
	tone256.RGB=drgb;
	tone256.STEP=mstp;

	mat=dvector(0,stp*(para+1));
	mat256=dvector(0,mstp*(para+1));//K255@̃e[u
	inv=dvector(0,(para+1)*stp);
	w=dvector(0,drgb*(para+1));

	for(i=0;i<stp;i++){//t@C͂ꂽ@K=stp̃e[u
		j=0;
		mat[i*(para+1)+j]=1;//ؕ(a0)
		j=1;
		mat[i*(para+1)+j]=tone[i];//(a1)
		for(j=2;j<para+1;j++){
			mat[i*(para+1)+j]=mat[i*(para+1)+j-1]*tone[i];
		}
	}

	for(i=0;i<mstp;i++){//K255@̃e[u
		j=0;
		mat256[i*(para+1)+j]=1;//ؕ(a0)
		j=1;
		mat256[i*(para+1)+j]=i;//(a1)
		for(j=2;j<para+1;j++){
			mat256[i*(para+1)+j]=mat256[i*(para+1)+j-1]*i;
		}
	}

	svdinv_zeromat1D(mat,inv,stp,para+1);

	for(i=0;i<drgb;i++){
		for(j=0;j<para+1;j++){
			w[i*(para+1)+j]=0;
			for(k=0;k<stp;k++){
				w[i*(para+1)+j]+=ip_sig[k*drgb+i]*inv[j*(stp)+k];
			}
		}
	}

	for(i=0;i<mstp;i++){
			for(j=0;j<drgb;j++){
				tone256.data[i*drgb+j]=0;
				for(k=0;k<para+1;k++){
					tone256.data[i*drgb+j]+=mat256[i*(para+1)+k]*w[j*(para+1)+k];
				}
			}
			if(i==mstp-1){
				for(j=0;j<drgb;j++){
					tone256.data[i*drgb+j]=1.0;
				}
			}
	}

	Fwrite_TABLE(fn_w,tone256.STEP,tone256.RGB,tone256.data);

	free_dvector(mat,0,stp*(para+1));
	free_dvector(mat256,0,mstp*(para+1));//K255@̃e[u
	free_dvector(inv,0,(para+1)*stp);
	free_dvector(w,0,drgb*(para+1));
	free_dvector(tone,0,stp*dim);
	free_dvector(ip_sig,0,stp*drgb);


	return tone256;


}

Tone ToneGet(char *fn)
{
	FILE *fp;
	Tone tone;
	char ch,temp[200];
	int s=0,nl=0;
	int i,j;

	strcpy(tone.fn,fn);

	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	while(fscanf(fp,"%c",&ch)!=EOF){
		if(ch=='\t'){
			s++;
		}
		if(ch=='\n'){
			nl++;
		}
	}
	fclose(fp);
	tone.RGB=(s+nl)/nl-1;//n񖼂Ăꍇ n񖼂͕K
	tone.STEP=nl-1;//n񖼂Ăꍇ n񖼂͕K
	printf("Number of RGB = %d\n",tone.RGB);
	printf("Signal Step = %d\n",tone.STEP);
	
	tone.data=dvector(0,(tone.STEP)*(tone.RGB));
	
	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	
	for(i=0;i<tone.RGB;i++){//Dim n񖼂ǂݔ΂
		fscanf(fp,"%s",temp);
	}
	
	for(i=0;i<tone.STEP;i++){
		fscanf(fp,"%s",temp);//Num n񖼂ǂݔ΂
	
		for(j=0;j<tone.RGB;j++){
			fscanf(fp,"%s",temp);
			tone.data[i*tone.RGB+j]=atof(temp);//f[^̓ǂݍ
		}
		
	}
	
	fclose(fp);
	
	return tone;
	
}

ToneTable ToneTableGet(char *fn_tone)
{
	int i,j,k;
	Tone	tone;
	tone=ToneGet(fn_tone);
	double dtmp,dpar;

	ToneTable tabl;
	tabl.Tone_Table_Min= 0.;
	tabl.Tone_Table_Max= 1.;
	tabl.Tone_Table_Size=10000;
	tabl.RGB=tone.RGB;
	tabl.STEP=tone.STEP;

	tabl.data=ucvector(0,tabl.Tone_Table_Size*tone.RGB);
	FILE *fp;
	fp=fopen("table.spec","w");

	for(i=0;i<tabl.Tone_Table_Size;i++){
		dtmp=(double)(1.0*i/tabl.Tone_Table_Size);
		dpar = dtmp * (tabl.Tone_Table_Max-tabl.Tone_Table_Min) + tabl.Tone_Table_Min;
		fprintf(fp,"%f\t",dpar);

		for(j=0;j<tone.RGB;j++){
			if(dpar>=tone.data[tone.RGB*(tone.STEP-1)+j]){
				tabl.data[tone.RGB*i+j]=tone.STEP-1;
			}else if(dpar<=tone.data[j]){
				tabl.data[tone.RGB*i+j]=0;
			}else{
				for(k=0;k<tone.STEP;k++){
					if(dpar<tone.data[tone.RGB*k+j]){
						tabl.data[tone.RGB*i+j]=k;
						break;
					}
				}
			}
		}

		for(j=0;j<tone.RGB;j++){
			fprintf(fp,"%d\t",tabl.data[tone.RGB*i+j]);
		}
		fprintf(fp,"\n");
	}
	fclose(fp);
	
	free_dvector(tone.data,0,(tone.STEP)*(tone.RGB));

	return tabl;

}

void RGBGet(double *irgb,unsigned char *orgb,ToneTable *table)
{
	int indx;
	double dtmp;
	int i;

	for(i=0;i<table->RGB;i++) {
		dtmp = (irgb[i]-table->Tone_Table_Min) / (table->Tone_Table_Max-table->Tone_Table_Min);
		indx = (int) ( dtmp * table->Tone_Table_Size ) ;
		if( dtmp > table->Tone_Table_Max ) indx = table->Tone_Table_Size-1;//dtmp =table->Tone_Table_Max;
		if( dtmp < table->Tone_Table_Min ) indx = 0;//dtmp = table->Tone_Table_Min;
		orgb[i]=table->data[table->RGB*indx+i];
	}
}

void Do_NVcolor(void)
{
	int i,j,k;
	char temp[200];
	char *fn_sys="16b.system";
	char *fn_wsig="..\\DATA\\ill3.001";

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	MSI Sig;//Multi Spectral Image of white , object	
	Sig.fn="..\\DATA\\HE3.001";
	Sig=MSI_wSig(Sig.fn);

	Spec	xyzfunc;//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	Disp	dsp;// XYZ͐Mlϊsi[
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);

	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone.spec";
	table=ToneTableGet(fn_tone);

	double *simSpec;////蓧ߗ
	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *xyz;//XYZl
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml
	simSpec=dvector(0,wimat.WL);
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	xyz=dvector(0,xyzfunc.Num);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);
	
	for(k=0;k<xyzfunc.Num;k++){//MlXYZϊs̍쐬@XYZF֐Wie  
		for(j=0;j<wimat.BAND;j++){
			StoX[k*wimat.BAND+j]=0;
			for(i=0;i<xyzfunc.WL;i+=wimat.INTERVAL){
				StoX[k*wimat.BAND+j]+=xyzfunc.data[i*xyzfunc.Num+k]*wimat.mat[i*wimat.BAND+j];
			}
		}
	}

	for(k=0;k<xyzfunc.Num;k++){
		xyz[k]=0;
		for(j=0;j<wimat.BAND;j++){
			xyz[k]+=StoX[k*wimat.BAND+j]*Sig.data[j];
		}
		xyz[k]-=dsp.back[k];
	}

	for(k=0;k<xyzfunc.Num;k++){//FMlXYZϊs̕␳
		irgb[k]=0;
		for(j=0;j<xyzfunc.Num;j++){
			irgb[k]+=dsp.XtoD[k*xyzfunc.Num+j]*xyz[j];
		}
	}

	RGBGet(irgb,orgb,&table);

	for(k=0;k<xyzfunc.Num;k++){//FMlXYZϊs̕␳
		
		printf("%f\t%d\n",irgb[k],orgb[k]);
	}

	ReName(Sig.fn,temp,"_testtoki.spec");
	Fwrite_SPEC(temp,wimat.WL,1,wimat.INTERVAL,simSpec);

	Fwrite_TABLE("table.txt",table.Tone_Table_Size,table.RGB,table.data);
	

	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);

	
	printf("I\n");
	getchar();
	
}

void Fwrite_StoXmat(char *fn_wsig){
	int i,j,k;
	char *fn_sys="16b.system";
	int SX=0,EX=2048;
	int SY=0,EY=2048;

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	double *StoX;//MlXYZϊs@Wie * XYZF֐
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	
	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	char fnw[200];
	ReName(fn_wsig,fnw,"_StoX.txt");

	Fwrite_TABLE(fnw,xyzfunc.Num,wimat.BAND,StoX);

	double *g;
	g=dvector(0,wimat.BAND);

	for(j=0;j<wimat.BAND;j++){
		g[j]=0;
		for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
			g[j]+=wimat.tr_H[k*wimat.BAND+j]*1;
		}
		printf("%dband %f\n",j,g[j]);
	}

	Fwrite_TABLE("liv1_ill.sig",wimat.BAND,1,g);


	getchar();

	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_dvector(StoX,0,xyzfunc.Num*wimat.BAND);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	

}

void NV_RGB(char *fn_wms,char *fn_oms){
	int i,j,k,x,y;
	char *fn_sys="16b.system";
	int SX=0,EX=2048;
	int SY=0,EY=2048;

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wms);//make wieners

	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);
	
	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);
	
	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);

	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}

	MSI msi;//Multi Spectral Image of object	
	msi=MSIGet(fn_oms);

	char fn_rgb[200];
	RGB rgb;
	ReName(msi.fn,fn_rgb,"_orirgb.raw");
	rgb=RGBinfo(&msi,fn_rgb);

	FILE *fp;
	printf("%s",fn_rgb);
	
	if((fp = fopen(rgb.fn, "wb")) == NULL ) {
		printf("%s I[vG[\n",rgb.fn);
		getchar();
		exit(1);
	}
	
	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){
			for(k=0;k<xyzfunc.Num;k++){//}`XyNgMlˌFPxl
				irgb[k]=0;
				for(j=0;j<wimat.BAND;j++){
						irgb[k]+=StoI[k*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}
			
			RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml
			
			for(k=0;k<xyzfunc.Num;k++){
				rgb.data[y*rgb.X*rgb.BAND+x*rgb.BAND+k]=orgb[k];
			}	
			fwrite(orgb,sizeof(unsigned char),rgb.BAND,fp);

		}

	}

	fclose(fp);

	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_ucvector(rgb.data,0,rgb.X*rgb.Y*rgb.BAND);
	free_dvector(StoX,0,xyzfunc.Num*wimat.BAND);
	free_dvector(StoI,0,table.RGB*wimat.BAND);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);
	
}

void Fwrite_NVmat(char *fn,Wie *wimat,double *mat)//bag 2006/12/10/
{
	FILE *fp;
	int i,j;
	if((fp=fopen(fn,"w"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}

	fprintf(fp,"\t");

	for(i=0;i<wimat->BAND;i++){//n񖼂̏o
		fprintf(fp,"BAND%d\t",i+1);
	}
	fprintf(fp,"\n");

	for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){
		fprintf(fp,"%d\t",i+1);
		for(j=0;j<wimat->BAND;j++){
			fprintf(fp,"%e\t",mat[wimat->BAND*i+j]);
		}
		fprintf(fp,"\n");
	}
	fclose(fp);
}
void ChangeBAND_MSI_sum(char *fn_band,char *fn_Osig)
{
	int j,k;
	int *BAND_table;
	int cBAND,Dim;
	int START,END;

	BAND_table=DataiGet(fn_band,&cBAND,&Dim);

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fn_g[200];
	char fn_t[200];
	sprintf(fn_t,"_%db.001",cBAND);
	ReName(msi.fn,fn_g,fn_t);

	printf("Make msi named as %s\n",fn_g);

	int x,y;
	int SX=0,EX=2048;
	int SY=0,EY=2048;


	FILE *fp;
	double *dg;
	unsigned short int *g;
	dg=dvector(0,cBAND);
	g=usvector(0,cBAND);


	if((fp = fopen(fn_g, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_g);
		getchar();
		exit(1);
	}


	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){

			for(k=0;k<cBAND;k++){
				dg[k]=0;
				START=BAND_table[k*Dim]-1;//START BAND1=0,BAND16=15
				END=BAND_table[k*Dim+1];//  END   BAND1=1,BAND16=16 
				for(j=START;j<END;j++){
					dg[k]+=msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
				dg[k]/=(END-START);
						
				g[k]=(unsigned short int)dg[k];
			}

			fwrite(g,sizeof(unsigned short int),cBAND,fp);

		}

	}

	fclose(fp);
	
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);


}

Wie ChangeBand_Wmat(char *fn_Sel,Wie *wimat)
{
	int i,j,k;
	int *BAND_table;
	int Num,Dim;
	int START,END;
	double *cCof,val;
	double *wsig;
	Wie cwimat;

	BAND_table=DataiGet(fn_Sel,&Num,&Dim);
	cwimat.BAND=Num;
	cwimat.START=wimat->START;
	cwimat.END=wimat->END;
	cwimat.WL=wimat->WL;
	cwimat.INTERVAL=wimat->INTERVAL;
	cwimat.NLEVEL=wimat->NLEVEL;
	cwimat.tr_H=dvector(0,cwimat.BAND*cwimat.WL);
	cwimat.Cov=dvector(0,cwimat.WL*cwimat.WL);
	cwimat.mat=dvector(0,cwimat.BAND*cwimat.WL);
	cCof=dvector(0,cwimat.BAND);
	wsig=dvector(0,cwimat.BAND);

	//make New system sensitivity 
	for(j=0;j<cwimat.BAND;j++){
		START=BAND_table[j*Dim]-1;//BAND1=0,BAND16=15
		END=BAND_table[j*Dim+1];//BAND1=0,BAND16=15
		for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){
			cwimat.tr_H[i*cwimat.BAND+j]=0;
			for(k=START;k<END;k++){// k<=END is very important !!
				cwimat.tr_H[i*cwimat.BAND+j]+=wimat->tr_H[i*wimat->BAND+k];
			}
		}
	}

	//i˗1j̎ɐMlSimuWhiteɂ
	for(j=0;j<cwimat.BAND;j++){
		wsig[j]=(double)SimuWhite;
	}
	
	for(j=0;j<cwimat.BAND;j++){
		val=0;
		for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){
			val+=cwimat.tr_H[i*cwimat.BAND+j]*1;//
		}
		cCof[j]=wsig[j]/val;
	}

	for(j=0;j<cwimat.BAND;j++){
		for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){
			cwimat.tr_H[i*cwimat.BAND+j]*=cCof[j];
		}
	}

	//make New wiener mat
	for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){
		for(j=wimat->START;j<wimat->END;j+=wimat->INTERVAL){
			cwimat.Cov[i*(wimat->END-wimat->START)+j]=wimat->Cov[i*(wimat->END-wimat->START)+j];
		}
	}
	cwimat.mat=WienerMat(&cwimat,wsig);

	free_ivector(BAND_table,0,Num*Dim);
	free_dvector(cCof,0,cwimat.BAND);
	free_dvector(wsig,0,cwimat.BAND);

	return cwimat;

}

void ChangeBAND_MSI(char *fn_band,char *fn_wsig,char *fn_Osig)
{
	int i,j;
	char *fn_sys="16b.system";

	Wie wimat,cwimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	cwimat=ChangeBand_Wmat(fn_band,&wimat);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fn_g[200];
	char fn_rgb[200];
	char fn_cg[200];

	RGB rgb;
	ReName(msi.fn,fn_rgb,"_rgb.raw");

	rgb=RGBinfo(&msi,fn_rgb);
	ReName(msi.fn,fn_g,"_3b.001");
	ReName(msi.fn,fn_cg,"_3b.raw");

	printf("%s\n",fn_rgb);
	printf("%s\n",fn_g);
	printf("%s\n",fn_cg);

	unsigned short int *g,*cg;
	double *dg,tg;
	unsigned char *chg;

#define RBAND 18
#define DARK 1
#define THROUGH 1

	dg=dvector(0,RBAND);
	g=usvector(0,RBAND);
	cg=usvector(0,RBAND);
	chg=ucvector(0,cwimat.BAND);

	int x,y;
	int SX=0,EX=2048;
	int SY=0,EY=2048;


	FILE *fp2,*fp3;


	if((fp2 = fopen(fn_g, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_g);
		getchar();
		exit(1);
	}
	if((fp3 = fopen(fn_cg, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_cg);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){
			
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
				simSpec[i]=0;
				for(j=0;j<wimat.BAND;j++){
					simSpec[i]+=wimat.mat[i*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}	

			for(j=0;j<cwimat.BAND;j++){
				dg[j]=0;
				for(i=cwimat.START;i<cwimat.END;i+=cwimat.INTERVAL){
					dg[j]+=cwimat.tr_H[i*cwimat.BAND+j]*simSpec[i];
				}
				
				tg=dg[j];
				g[j]=(unsigned short int)dg[j];
				chg[j]=(unsigned char)(dg[j]/SimuWhite*255);


			}

			fwrite(g,sizeof(unsigned short int),cwimat.BAND,fp2);
			fwrite(chg,sizeof(unsigned char),cwimat.BAND,fp3);

		}

	}

	fclose(fp2);
	fclose(fp3);
	
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_dvector(simSpec,0,wimat.WL);

	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.Cov,0,wimat.WL*wimat.WL);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	
	free_dvector(cwimat.mat,0,cwimat.WL*cwimat.BAND);
	free_dvector(cwimat.tr_H,0,cwimat.WL*cwimat.BAND);
	free_dvector(cwimat.Cov,0,cwimat.WL*cwimat.WL);
	
	//getchar();


}

void FwriteChangeBandMatrix(char *fn_band,char *fn_wsig)
{
	char *fn_sys="16b.system";
	char fn_refil[200];
	char fn_cwmat[200];
	
	Wie wimat,cwimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	cwimat=ChangeBand_Wmat(fn_band,&wimat);

	ReName(fn_band,fn_refil,"_Hmat.spec");
	Fwrite_NVmat(fn_refil,&cwimat,cwimat.tr_H);

	ReName(fn_band,fn_cwmat,"_Wmat.spec");
	Fwrite_NVmat(fn_cwmat,&cwimat,cwimat.mat);


	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.Cov,0,wimat.WL*wimat.WL);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	
	free_dvector(cwimat.mat,0,cwimat.WL*cwimat.BAND);
	free_dvector(cwimat.tr_H,0,cwimat.WL*cwimat.BAND);
	free_dvector(cwimat.Cov,0,cwimat.WL*cwimat.WL);

}


void ChangeBAND_MSI(char *fn_wsig,char *fn_Osig)
{
	int i,j;
	char *fn_sys="16b.system";
	char *fn_3band="..\\DATA\\3band.sel";
	char *fn_6band="..\\DATA\\6band.sel";
	char *fn_9band="..\\DATA\\9band.sel";
	char *fn_12band="..\\DATA\\12band.sel";
	char *fn_16band="..\\DATA\\16band.sel";
	
	Wie wimat,cwimat3b,cwimat6b,cwimat9b,cwimat12b,cwimat16b;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners
	cwimat3b=ChangeBand_Wmat(fn_3band,&wimat);
	cwimat6b=ChangeBand_Wmat(fn_6band,&wimat);
	cwimat9b=ChangeBand_Wmat(fn_9band,&wimat);
	cwimat12b=ChangeBand_Wmat(fn_12band,&wimat);
	cwimat16b=ChangeBand_Wmat(fn_16band,&wimat);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fn_3g[200],fn_6g[200],fn_9g[200],fn_12g[200],fn_16g[200];


	ReName(msi.fn,fn_3g,"_3b.001");
	ReName(msi.fn,fn_6g,"_6b.001");
	ReName(msi.fn,fn_9g,"_9b.001");
	ReName(msi.fn,fn_12g,"_12b.001");
	ReName(msi.fn,fn_16g,"_16b.001");


	printf("%s\n",fn_3g);
	printf("%s\n",fn_6g);
	printf("%s\n",fn_9g);
	printf("%s\n",fn_12g);
	printf("%s\n",fn_16g);


	unsigned short int *g3b,*g6b,*g9b,*g12b,*g16b;
	double *dg;


	dg=dvector(0,wimat.BAND);
	g3b=usvector(0,cwimat3b.BAND);
	g6b=usvector(0,cwimat6b.BAND);
	g9b=usvector(0,cwimat9b.BAND);
	g12b=usvector(0,cwimat12b.BAND);
	g16b=usvector(0,cwimat16b.BAND);

	int x,y;
	int SX=0,EX=2048;
	int SY=0,EY=2048;


	FILE *fp3,*fp6,*fp9,*fp12,*fp16;



	if((fp3 = fopen(fn_3g, "wb")) == NULL ) {//Make 3b fp3
		printf("%s I[vG[\n",fn_3g);
		getchar();
		exit(1);
	}
	if((fp6 = fopen(fn_6g, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_6g);
		getchar();
		exit(1);
	}
	if((fp9 = fopen(fn_9g, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_9g);
		getchar();
		exit(1);
	}
	if((fp12 = fopen(fn_12g, "wb")) == NULL ) { //Make 12b fp12
		printf("%s I[vG[\n",fn_12g);
		getchar();
		exit(1);
	}
	if((fp16 = fopen(fn_16g, "wb")) == NULL ) {//Make 16b fp16
		printf("%s I[vG[\n",fn_16g);
		getchar();
		exit(1);
	}



	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){
			
			for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){//蓧ߗZo
				simSpec[i]=0;
				for(j=0;j<wimat.BAND;j++){
					simSpec[i]+=wimat.mat[i*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}	
			
			//Make 3b fp3
			for(j=0;j<cwimat3b.BAND;j++){
				dg[j]=0;
				for(i=cwimat3b.START;i<cwimat3b.END;i+=cwimat3b.INTERVAL){
					dg[j]+=cwimat3b.tr_H[i*cwimat3b.BAND+j]*simSpec[i];
				}
				if(dg[j]>SimuWhite)dg[j]=SimuWhite;
				if(dg[j]<0)dg[j]=0;
				g3b[j]=(unsigned short int)dg[j];

			}
			fwrite(g3b,sizeof(unsigned short int),cwimat3b.BAND,fp3);

			//Make 6b fp6
			for(j=0;j<cwimat6b.BAND;j++){
				dg[j]=0;
				for(i=cwimat6b.START;i<cwimat6b.END;i+=cwimat6b.INTERVAL){
					dg[j]+=cwimat6b.tr_H[i*cwimat6b.BAND+j]*simSpec[i];
				}
				if(dg[j]>SimuWhite)dg[j]=SimuWhite;
				if(dg[j]<0)dg[j]=0;
				g6b[j]=(unsigned short int)dg[j];

			}
			fwrite(g6b,sizeof(unsigned short int),cwimat6b.BAND,fp6);

			//Make 9b fp9
			for(j=0;j<cwimat9b.BAND;j++){ 
				dg[j]=0;
				for(i=cwimat9b.START;i<cwimat9b.END;i+=cwimat9b.INTERVAL){
					dg[j]+=cwimat9b.tr_H[i*cwimat9b.BAND+j]*simSpec[i];
				}
				if(dg[j]>SimuWhite)dg[j]=SimuWhite;
				if(dg[j]<0)dg[j]=0;
				g9b[j]=(unsigned short int)dg[j];

			}
			fwrite(g9b,sizeof(unsigned short int),cwimat9b.BAND,fp9);

			//Make 12b fp12
			for(j=0;j<cwimat12b.BAND;j++){
				dg[j]=0;
				for(i=cwimat12b.START;i<cwimat12b.END;i+=cwimat12b.INTERVAL){
					dg[j]+=cwimat12b.tr_H[i*cwimat12b.BAND+j]*simSpec[i];
				}
				if(dg[j]>SimuWhite)dg[j]=SimuWhite;
				if(dg[j]<0)dg[j]=0;
				g12b[j]=(unsigned short int)dg[j];

			}
			fwrite(g12b,sizeof(unsigned short int),cwimat12b.BAND,fp12);

			//Make 16b fp16
			for(j=0;j<cwimat16b.BAND;j++){
				dg[j]=0;
				for(i=cwimat16b.START;i<cwimat16b.END;i+=cwimat16b.INTERVAL){
					dg[j]+=cwimat16b.tr_H[i*cwimat16b.BAND+j]*simSpec[i];
				}
				if(dg[j]>SimuWhite)dg[j]=SimuWhite;
				if(dg[j]<0)dg[j]=0;
				g16b[j]=(unsigned short int)dg[j];

			}
			fwrite(g16b,sizeof(unsigned short int),cwimat16b.BAND,fp16);	


		}

	}

	fclose(fp3);
	fclose(fp6);
	fclose(fp9);
	fclose(fp12);
	fclose(fp16);
	
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_dvector(simSpec,0,wimat.WL);

	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.Cov,0,wimat.WL*wimat.WL);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	
	free_dvector(cwimat3b.mat,0,cwimat3b.WL*cwimat3b.BAND);
	free_dvector(cwimat3b.tr_H,0,cwimat3b.WL*cwimat3b.BAND);
	free_dvector(cwimat3b.Cov,0,cwimat3b.WL*cwimat3b.WL);

	free_dvector(cwimat6b.mat,0,cwimat6b.WL*cwimat6b.BAND);
	free_dvector(cwimat6b.tr_H,0,cwimat6b.WL*cwimat6b.BAND);
	free_dvector(cwimat6b.Cov,0,cwimat6b.WL*cwimat6b.WL);

	free_dvector(cwimat9b.mat,0,cwimat9b.WL*cwimat9b.BAND);
	free_dvector(cwimat9b.tr_H,0,cwimat9b.WL*cwimat9b.BAND);
	free_dvector(cwimat9b.Cov,0,cwimat9b.WL*cwimat9b.WL);

	free_dvector(cwimat12b.mat,0,cwimat12b.WL*cwimat12b.BAND);
	free_dvector(cwimat12b.tr_H,0,cwimat12b.WL*cwimat12b.BAND);
	free_dvector(cwimat12b.Cov,0,cwimat12b.WL*cwimat12b.WL);

	free_dvector(cwimat16b.mat,0,cwimat16b.WL*cwimat16b.BAND);
	free_dvector(cwimat16b.tr_H,0,cwimat16b.WL*cwimat16b.BAND);
	free_dvector(cwimat16b.Cov,0,cwimat16b.WL*cwimat16b.WL);

	
	//getchar();


}

void USimgConvertRGB(char *fn)
{
	FILE *fp;
	unsigned short int *ug;
	unsigned char *cg;
	int DATASIZE;
	int SIZE;
	int i;

	char refn[200];

	ReName(fn,refn,"_char.raw");
	printf("%s\n",refn);
	
	if((fp = fopen(fn, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn);
		getchar();
		exit(1);
	}

	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	DATASIZE=ftell(fp);
	fseek(fp,  0L, SEEK_SET);
	SIZE=DATASIZE/sizeof(unsigned short int);

	printf("f[^ = %d@\n",SIZE);
	
	ug=usvector(0,SIZE);
	cg=ucvector(0,SIZE);
	
	fread(ug,sizeof(unsigned short int),SIZE,fp);
	fclose(fp);


	for(i=0;i<SIZE;i++){
		cg[i]=(unsigned char)(ug[i]/255);
		if(cg[i]<0)cg[i]=0;
		if(cg[i]>255)cg[i]=255;
	}

	if((fp = fopen(refn, "wb")) == NULL ) {
		printf("%s I[vG[\n",refn);
		getchar();
		exit(1);
	}
	fwrite(cg,sizeof(unsigned char),SIZE,fp);
	fclose(fp);

	free_usvector(ug,0,SIZE);
	free_ucvector(cg,0,SIZE);
	

}

void changeband(void)
{
	char *fn_wsig="F:\\2004\\Sep\\pitsamp2\\ob20\\liv1\\liv1_ill.001";//illumination
	char *fn_Osig="F:\\2004\\Sep\\pitsamp2\\ob20\\liv1\\liv1_p1.001";//test

	time_t time1, time2;

	time(&time1);
	ChangeBAND_MSI(fn_wsig,fn_Osig);	
	time(&time2);
	printf("1: %fb\n", difftime(time2,time1));

	time(&time1);

	fn_Osig="F:\\2004\\Sep\\pitsamp2\\ob20\\liv17\\liv17_p1.001";//test
	ChangeBAND_MSI(fn_wsig,fn_Osig);
	
	fn_Osig="F:\\2004\\Sep\\pitsamp2\\ob20\\liv7\\liv7_p1.001";//test
	ChangeBAND_MSI(fn_wsig,fn_Osig);

	fn_Osig="F:\\2004\\Sep\\pitsamp2\\ob20\\liv9\\liv9_p1.001";//test
	ChangeBAND_MSI(fn_wsig,fn_Osig);

	fn_Osig="F:\\2004\\Sep\\pitsamp2\\ob20\\liv15\\liv15_p1.001";//test
	ChangeBAND_MSI(fn_wsig,fn_Osig);

	time(&time2);
	printf("2-5: %fb\n", difftime(time2,time1));

	getchar();
	


}

ROI ROIGet(char *fn)
{
	FILE *fp;
	ROI roi;
	char ch,temp[200];
	int nl=0,s=0;
	int i;
	
	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	while(fscanf(fp,"%c",&ch)!=EOF){
		/*if(ch=='\t'){
			s++;
		}*/
		if(ch=='\n'){
			nl++;
		}
	}
	fclose(fp);
	
	roi.Num=nl;//n񖼂ĂȂꍇ
	printf("Number of Data = %d\n",roi.Num);
	
	roi.SX=ivector(0,roi.Num);
	roi.SY=ivector(0,roi.Num);
	roi.EX=ivector(0,roi.Num);
	roi.EY=ivector(0,roi.Num);
	roi.AREA=dvector(0,roi.Num);
	
	if((fp=fopen(fn,"r"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}
	
	for(i=0;i<roi.Num;i++){
		fscanf(fp,"%s",temp);
		roi.SX[i]=atoi(temp);//f[^̓ǂݍ
		fscanf(fp,"%s",temp);
		roi.SY[i]=atoi(temp);//f[^̓ǂݍ
		fscanf(fp,"%s",temp);
		roi.EX[i]=atoi(temp);//f[^̓ǂݍ
		fscanf(fp,"%s",temp);
		roi.EY[i]=atoi(temp);//f[^̓ǂݍ
		roi.AREA[i]=(roi.EY[i]-roi.SY[i])*(roi.EX[i]-roi.SX[i]);
	}
	
	fclose(fp);
	
	return roi;
	
}

void Fwrite_ROI(char *fn,ROI *roi)//bag 2006/12/10/
{
	FILE *fp;
	int i;
	if((fp=fopen(fn,"w"))==NULL){
		printf("%s file open error!!\n",fn);
		getchar();
		exit(1);
	}

	for(i=0;i<roi->Num;i++){//n񖼂̏o
		fprintf(fp,"%d\t",roi->SX[i]);
		fprintf(fp,"%d\t",roi->SY[i]);
		fprintf(fp,"%d\t",roi->EX[i]);
		fprintf(fp,"%d\t",roi->EY[i]);
	//	fprintf(fp,"%f\t",roi->AREA[i]);
		fprintf(fp,"\n");
	}
}

double *XYZtoLab(double *xyz,double *wxyz,int Num,int Dim)
{
	double *Lab;
	int i;
	Lab=dvector(0,Num*Dim);

	for(i=0;i<Num;i++){
		Lab[i*Dim+0]=116*pow(xyz[i*Dim+0]/wxyz[0],1.0/3)-16;//L[i]
		Lab[i*Dim+1]=pow(xyz[i*Dim+0]/wxyz[0],1.0/3)-pow(xyz[i*Dim+1]/wxyz[1],1.0/3);
		Lab[i*Dim+1]*=500;//a[i]
		Lab[i*Dim+2]=pow(xyz[i*Dim+1]/wxyz[1],1.0/3)-pow(xyz[i*Dim+2]/wxyz[2],1.0/3);
		Lab[i*Dim+2]*=200;//b[i]
	}

	return Lab;

}

void Lab(void)
{
	int i;
	char *fn="RBC_weihgtLB(R(opt)R(overE)HE).xyz";//object
	char *fn_wh="Ill.xyz";//white

	FILE *fp;
	
	double *xyz;
	int Num,Dim;
	double *wxyz;
	int wNum,wDim;
	double *Lab;

	char fnw[200];
	ReName(fn,fnw,".lab");
	printf("File as named '%s' is generated!!\n ",fnw);

	xyz=DataGet(fn,&Num,&Dim);
	Lab=dvector(0,Num*Dim);
	wxyz=DataGet(fn_wh,&wNum,&wDim);

	Lab=XYZtoLab(xyz,wxyz,Num,Dim);

	if((fp=fopen(fnw,"w"))==NULL){
		printf("%s file open error!!\n",fnw);
		getchar();
		exit(1);
	}

	for(i=0;i<Num;i++){
		fprintf(fp,"n%d\t%f\t%f\t%f\n",i+1,Lab[i*Dim+0],Lab[i*Dim+1],Lab[i*Dim+2]);
	}

	fclose(fp);

	free_dvector(Lab,0,Num*Dim);
	free_dvector(xyz,0,Num*Dim);
	free_dvector(wxyz,0,wNum*wDim);

}

void NV_Bar(char *fn_wms,char *fn_oms){//@fn_wms͔摜@fn_omsɂ͓ߗf[^
	int i,j,k;
	char *fn_sys="16b.system";

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wms);//make wieners

	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);
	
	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);
	
	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);

	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}

	double *Tra,*wsig,*g;
	int Num,Dim;
	double *irgb;//͐Ml
	unsigned char *orgb,*orgb2;//o͐Ml

	Tra=DataGet(fn_oms,&Num,&Dim);//ߗf[^ǂݍ
	wsig=dvector(0,wimat.BAND);
	g=dvector(0,Num*Dim);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);
	orgb2=ucvector(0,Num*table.RGB);

	char fn_rgb[200];
	ReName(fn_oms,fn_rgb,"_rgbbar.raw");//o̓t@C쐬

	for(j=0;j<wimat.BAND;j++){//MlvZ
		wsig[j]=0;
		for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){
			wsig[j]+=wimat.tr_H[k*wimat.BAND+j]*1;
		}
	}

	for(i=0;i<Num;i++){//MlZo
		for(j=0;j<wimat.BAND;j++){
			g[i*wimat.BAND+j]=wsig[j]*Tra[i*wimat.BAND+j];
		}
	}
	Fwrite_TABLE("test_g.xls",Num,wimat.BAND,g);

	for(i=0;i<Num;i++){//o͐MlZo
		for(k=0;k<xyzfunc.Num;k++){//}`XyNgMlˌFPxl
			irgb[k]=0;
			for(j=0;j<wimat.BAND;j++){
				irgb[k]+=StoI[k*wimat.BAND+j]*g[i*wimat.BAND+j];
			}
		}

		RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml
		for(k=0;k<xyzfunc.Num;k++){
			orgb2[i*xyzfunc.Num+k]=orgb[k];
			printf("%d\t",orgb[k]);
		}
		printf("\n");
	}

	int SZ=200;
	int row=3;//s
	int colum;//

	colum=Num/row;//

	FILE *fp;
	int x,y,n;

	printf("Out %s file !!\n",fn_rgb);

	if((fp = fopen(fn_rgb, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_rgb);
		getchar();
		exit(1);
	}

	for(y=0;y<row*SZ;y++){
		for(x=0;x<colum*SZ;x++){
			i=(int)y/SZ;
			j=(int)x/SZ;
			n=i*colum+j;
			for(k=0;k<xyzfunc.Num;k++){
				orgb[k]=orgb2[n*xyzfunc.Num+k];
			}
			fwrite(orgb,sizeof(unsigned char),xyzfunc.Num,fp);
		}
	}
	fclose(fp);
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);

	free_dvector(StoX,0,xyzfunc.Num*wimat.BAND);
	free_dvector(StoI,0,table.RGB*wimat.BAND);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);
	
}

/*******************************************
*	made by MT
*	g->XYZ->Lab
*	using wiener
*	unsigned short int ^ŏo
*	E(color difference)Zo
*/


void NV_XYZ(char *fn_wms,char *fn_oms,char *fn_sys){
	int i,j,k,x,y;
//	char *fn_sys="16b.system";
	int SX=0,EX=2048;
	int SY=0,EY=2048;

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wms);//make wieners

	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	double *StoX;//MlXYZϊs@Wie * XYZF֐
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);

	double *xyz;//XYZOhl
	xyz=dvector(0,xyzfunc.Num);

	double *whi_xyz;
	whi_xyz=dvector(0,xyzfunc.Num);	

	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnXYZOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(k=0;k<xyzfunc.Num;k++){//}`XyNgMlˌFPxl
		whi_xyz[k]=0;
		for(j=wimat.START;j<wimat.END;j+=wimat.INTERVAL){
			whi_xyz[k]+=xyzfunc.data[k*xyzfunc.Num+j]*1;
		}
	}

	MSI msi;//Multi Spectral Image of object	
	msi=MSIGet(fn_oms);

	char fn_xyzimg[200];
	ReName(msi.fn,fn_xyzimg,"_xyz.raw");

	FILE *fp;
	printf("%s",fn_xyzimg);
	
	if((fp = fopen(fn_xyzimg, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_xyzimg);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){
			for(k=0;k<xyzfunc.Num;k++){//}`XyNgMlˌFPxl
				xyz[k]=0;
				for(j=0;j<wimat.BAND;j++){
						xyz[k]+=StoX[k*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}
			
			fwrite(xyz,sizeof(double),xyzfunc.Num,fp);

		}

	}
	

	fclose(fp);
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	
	free_dvector(StoX,0,xyzfunc.Num*wimat.BAND);


	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);

}

void XYZtoLAB(double *xyz,double *wxyz,double *Lab){

	//initialize Lab
	int SpaceDim=3;

	for(int i=0;i<SpaceDim;i++){
	Lab[i]=0;
	}

	if(xyz[0]/wxyz[0]>0.00856)	Lab[0]=	116*pow(xyz[1]/wxyz[1],1.0/3)-16;
	else Lab[0] = 903.29*(xyz[0]/wxyz[0]);

	Lab[1]=500*(pow(xyz[0]/wxyz[0],1.0/3)-pow(xyz[1]/wxyz[1],1.0/3));

	Lab[2]=200*(pow(xyz[1]/wxyz[1],1.0/3)-pow(xyz[2]/wxyz[2],1.0/3));

}
void NV_LAB(char *fn_wms,char *fn_oms,char *fn_sys){
	int i,j,k,x,y;
//	char *fn_sys="16b.system";
	int SX=0,EX=2048;
	int SY=0,EY=2048;

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wms);//make wieners

	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	double *StoX;//MlXYZϊs@Wie * XYZF֐
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);

	double *xyz;//XYZOhl
	xyz=dvector(0,xyzfunc.Num);

	double *lab;//LABl
	lab=dvector(0,xyzfunc.Num);

	double *whi_xyz;
	whi_xyz=dvector(0,xyzfunc.Num);	

	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnXYZOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(k=0;k<xyzfunc.Num;k++){//}`XyNgMlˌFPxl
		whi_xyz[k]=0;
		for(j=wimat.START;j<wimat.END;j+=wimat.INTERVAL){
			whi_xyz[k]+=xyzfunc.data[j*xyzfunc.Num+k];
		}
	}

	for(k=0;k<xyzfunc.Num;k++){
		printf("%f\t",whi_xyz[k]);
	}
	printf("\n");


	MSI msi;//Multi Spectral Image of object	
	msi=MSIGet(fn_oms);

	char fn_labimg[200];
	ReName(msi.fn,fn_labimg,"_lab.raw");

	FILE *fp;
	printf("%s",fn_labimg);
	
	if((fp = fopen(fn_labimg, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_labimg);
		getchar();
		exit(1);
	}

	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){
			for(k=0;k<xyzfunc.Num;k++){//}`XyNgMlˌFPxl
				xyz[k]=0;
				for(j=0;j<wimat.BAND;j++){
						xyz[k]+=StoX[k*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}
			XYZtoLAB(xyz,whi_xyz,lab);
			fwrite(lab,sizeof(double),xyzfunc.Num,fp);
		}
	}

	fclose(fp);
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_dvector(StoX,0,xyzfunc.Num*wimat.BAND);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
}
//input		Lab file 
//output	dE

void dE_color_diff(char *orig_lab_fn,char *comp_lab_fn){
	
	//ɉ摜擾̃ASYƂ肠

	int ImageSize = 2048*2048;
	int SpaceDim = 3;

	char fnw[200];
	ReName(comp_lab_fn,fnw,"_LABE.txt");


	//color difference dE
	double dE=0;
	double E;
	double aveE=0;

	FILE *fp1,*fp2;
	double *orgb,*crgb,*orgb_lab,*comp_lab;
	
	//for read Lab file
	orgb = dvector(0,ImageSize*SpaceDim);
	crgb = dvector(0,ImageSize*SpaceDim);

	//for color difference
	orgb_lab=dvector(0,SpaceDim);
	comp_lab=dvector(0,SpaceDim);

	if((fp1 = fopen(orig_lab_fn,"rb")) == NULL){
		printf("%s I[vG[\n",orig_lab_fn);
		getchar();
		exit(1);
	}
	fread(orgb,sizeof(double),ImageSize*SpaceDim,fp1);
	fclose(fp1);

	if((fp2 = fopen(comp_lab_fn,"rb")) == NULL){
		printf("%s I[vG[\n",comp_lab_fn);
		getchar();
		exit(1);
	}
	fread(crgb,sizeof(double),ImageSize*SpaceDim,fp2);
	fclose(fp2);

	
	for(int i=0;i<ImageSize;i++){
		for(int j=0;j<SpaceDim;j++){
			orgb_lab[j]= orgb[i*SpaceDim+j];
			comp_lab[j]= crgb[i*SpaceDim+j];
		//	printf("%f\t",orgb_lab[j]);
		}
		
		//dE += color_diff(orgb_lab,comp_lab);
		E	= color_diff(orgb_lab,comp_lab);
		aveE += E;
	}
	aveE/=ImageSize;

	
	printf("%s̃t@C\tF\n%f\n",comp_lab_fn,aveE);

	Fwrite_ProfileData(fnw,1,1,&aveE);
	
	free_dvector(orgb,0,ImageSize*SpaceDim);
	free_dvector(crgb,0,ImageSize*SpaceDim);
	free_dvector(orgb_lab,0,SpaceDim);
	free_dvector(comp_lab,0,SpaceDim);
	fclose(fp1);
	fclose(fp2);

}

double color_diff(double *orig_lab,double *comp_lab){

	double dE=0;
	int SpaceDim = 3;

	for(int i=0;i<SpaceDim;i++){
		dE	+=	(orig_lab[i] - comp_lab[i])*(orig_lab[i] - comp_lab[i]); 	
	}

	dE = pow(dE,1.0/2);	
	
	return dE;
}

Wie Do_WmatIMSPEC(void)//
{
	Wie wimat;
	wimat.BAND=81;
	wimat.WL=401;
	wimat.INTERVAL=5;// sampling interval********************************************

	wimat.START=0;
	wimat.END=401;
	
	return wimat;
}

Wie Do_WmatIMSPEC(char *fn_sys, char *fn_wSig)
{
	int IMSPEC_INTERVAL=5;//Imspector of sampling interval
	int IMSPEC_START=380;
	int IMSPEC_END=780;

	FILE *fp;
	char temp[200];

	Wie wimat;
	MSI wSig;//Multi Spectral Image of white 
	char fn_Tra[100];//Mesured Transmittance is Priori Information
	Spec iIll;// Input Radiance of illumination
	Spec CCD;//Sensitivity of CCD Camera
	Spec Fil;//Spectral Transmittance of N BAND Fillters

	wSig.fn=fn_wSig;

	if((fp=fopen(fn_sys,"r"))==NULL){
		printf("%s file open error!!\n",fn_sys);
		getchar();
		exit(1);
	}
	fscanf(fp,"%s",temp);// hPrioriInformationh@ǂݔ΂
	fscanf(fp,"%s",fn_Tra);
	fscanf(fp,"%s",temp);// hinputIlluminationh@ǂݔ΂
	fscanf(fp,"%s",iIll.fn);
	fscanf(fp,"%s",temp);// hCCDSnsitivityh@ǂݔ΂
	fscanf(fp,"%s",CCD.fn);
	fscanf(fp,"%s",temp);// hFilterh@ǂݔ΂
	fscanf(fp,"%s",Fil.fn);

	fclose(fp);



	wSig=MSI_wSig(wSig.fn);//Ml̒o
	iIll=SpecGet(iIll.fn);//ˌXyNgi[
	CCD=SpecGet(CCD.fn);//CCDxi[
	Fil=SpecGet(Fil.fn);//̃tB^[ߗi[

	//iIll CCD Fil ̔g`FbNvO쐬
	

	wimat.BAND=Fil.Num;
	wimat.WL=Fil.WL;
	wimat.INTERVAL=5;// Imspector of sampling interval********************************************
	wimat.NLEVEL=iniNLEVEL;//Noise Level*************************************************

	if(wimat.BAND!=wSig.BAND){
		printf("%s is not system matrix for \n%s!!\n",fn_sys,wSig.fn);
		getchar();
		exit(1);
	}
	
	if(IMSPEC_START<=iIll.START){
		wimat.START=0;
	}else{
		wimat.START=IMSPEC_START-iIll.START;
	}
	if(IMSPEC_END>=iIll.END){
		wimat.END=iIll.END-iIll.START+1;
	}else{
		wimat.END=IMSPEC_END-iIll.START+1;//REVISE 2007/04/11
		if(wimat.END>401){
			printf("%s file is over wavelength dimension!!\n",iIll.fn);
		}
	}
	
	printf("Wiener matrix is used covariance obtained by marcov chain.\n");
	wimat.Cov=wieMCOV(iniProb,wimat.WL,wimat.INTERVAL,wimat.START,wimat.END);//Us̎Zo

	
	wimat.tr_H=SysMat(&wimat,&Fil,&CCD,&iIll,&wSig);//VXesvZ
	wimat.mat=WienerMat(&wimat,&wSig);//wienersvZ

	free_dvector(Fil.data,0,Fil.WL*Fil.Num);
	free_dvector(CCD.data,0,CCD.WL*CCD.Num);
	free_dvector(iIll.data,0,iIll.WL*iIll.Num);

	return wimat;

}

void GetSignal(char *fn_wsig,char *fn_Osig,char *fn_ROI)
{
	int i,j,x,y,n;

	//********************************  ΏۂMSI@@ǂݍ *****************************************************
	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	//********************************  MSI@@ǂݍ *****************************************************
	MSI wmsi;//Multi Spectral Image of object	
	wmsi.fn=fn_wsig;//"..\\DATA\\HE3.001";
	wmsi=MSIGet(wmsi.fn);

	//******************************** ROI@ǂݍ *****************************************************
	char fng[200];// signal data
	ReName(fn_ROI,fng,"_sig.txt");
	printf("%s\n",fng);

	ROI roi;
	roi=ROIGet(fn_ROI);
	Fwrite_ROI("test_miyazawa.xls",&roi);//mFp@ROIo̓t@C

	FILE *fp;
	double *dg,*wg,*tg;

	dg=dvector(0,msi.BAND);//Ώۉ摜ROÏ̕ϐMl
	wg=dvector(0,wmsi.BAND);//摜ROÏ̕ϐMl
	tg=dvector(0,wmsi.BAND);//ROÏ̕ϓߗMl

	if((fp = fopen(fng, "w")) == NULL ) {
		printf("%s I[vG[\n",fng);
		getchar();
		exit(1);
	}

	printf("%dband data\n",msi.BAND);
	printf("Output Trans data\n");

		
	fprintf(fp,"\t");
	for(i=0;i<msi.BAND;i++){
			fprintf(fp,"BAND%d\t",i+1);
	}
	fprintf(fp,"\n");


	for(n=0;n<roi.Num;n++){//ROI̐for[v
		for(j=0;j<msi.BAND;j++){
			dg[j]=0;
			wg[j]=0;
			for(y=roi.SY[n];y<roi.EY[n];y++){
				for(x=roi.SX[n];x<roi.EX[n];x++){
					dg[j]+=msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
					wg[j]+=wmsi.data[y*wmsi.X*wmsi.BAND+x*wmsi.BAND+j];
				}
			}
			dg[j]/=roi.AREA[j];
			wg[j]/=roi.AREA[j];
			tg[j]=dg[j]/wg[j];
		}

		fprintf(fp,"DATA%d\t",n+1);
		for(j=0;j<msi.BAND;j++){
			fprintf(fp,"%.4f\t",tg[j]);
		}
		fprintf(fp,"\n");

	}
	fclose(fp);


	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);

}

void NV_RGB(char *fn_sys,char *fn_wms,char *fn_oms){
	int i,j,k,x,y;
//	char *fn_sys="16b.system";
	int SX=0,EX=2048;
	int SY=0,EY=2048;

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wms);//make wieners

	//F֐ Y=100 ŕ␳Ċώ@̏ƖZĂ
	Spec	xyzfunc;
	char	fn_xyz[]="..\\DATA\\s_xyz(401dim).spec";
	char	fn_oIll[]="..\\DATA\\oIll_401.spec";
	xyzfunc=xyzSpecGet(fn_xyz,fn_oIll,wimat.START,wimat.END,wimat.INTERVAL);
	
	// XYZ͐Mlϊsi[
	Disp	dsp;
	char	fn_prima[]="..\\DATA\\iiyama_primary401.spec";
	dsp=DispGet(fn_prima,xyzfunc,wimat.START,wimat.END,wimat.INTERVAL);
	Fwrite_TABLE("XtoD.txt",xyzfunc.Num,xyzfunc.Num,dsp.XtoD);
	
	// fBXvC̋tK}̍쐬Fo͋Pxl͐Ml̃e[u
	ToneTable	table;
	char fn_tone[]="..\\DATA\\iiyamatone_bias.spec";//͐Mlo͋Pxl̃e[u
	table=ToneTableGet(fn_tone);
	
	double *StoX;//MlXYZϊs@Wie * XYZF֐
	double *StoI;//Mlrgbϊs@Wie * XYZF֐@* XYZrgbϊs
	double *irgb;//͐Ml
	unsigned char *orgb;//o͐Ml
	StoX=dvector(0,xyzfunc.Num*wimat.BAND);
	StoI=dvector(0,table.RGB*wimat.BAND);
	irgb=dvector(0,table.RGB);
	orgb=ucvector(0,table.RGB);

	for(i=0;i<xyzfunc.Num;i++){//}`XyNg摜MnxyzOhlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoX[i*wimat.BAND+j]=0;
			for(k=wimat.START;k<wimat.END;k+=wimat.INTERVAL){//蓧ߗZo
				StoX[i*wimat.BAND+j]+=xyzfunc.data[k*xyzfunc.Num+i]*wimat.mat[k*wimat.BAND+j];
			}
		}
	}

	for(i=0;i<table.RGB;i++){//}`XyNg摜MnrgbPxlւ̕ϊs쐬
		for(j=0;j<wimat.BAND;j++){
			StoI[i*wimat.BAND+j]=0;
				for(k=0;k<xyzfunc.Num;k++){
					StoI[i*wimat.BAND+j]+=dsp.XtoD[i*table.RGB+k]*StoX[k*wimat.BAND+j];
				}
		}
	}

	MSI msi;//Multi Spectral Image of object	
	msi=MSIGet(fn_oms);

	char fn_rgb[200];
	RGB rgb;
	ReName(msi.fn,fn_rgb,"_orirgb.raw");
	rgb=RGBinfo(&msi,fn_rgb);

	FILE *fp;
	printf("%s",fn_rgb);
	
	if((fp = fopen(rgb.fn, "wb")) == NULL ) {
		printf("%s I[vG[\n",rgb.fn);
		getchar();
		exit(1);
	}
	
	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){
			for(k=0;k<xyzfunc.Num;k++){//}`XyNgMlˌFPxl
				irgb[k]=0;
				for(j=0;j<wimat.BAND;j++){
						irgb[k]+=StoI[k*wimat.BAND+j]*msi.data[y*msi.X*msi.BAND+x*msi.BAND+j];
				}
			}
			
			RGBGet(irgb,orgb,&table);//FPxlˏo͐Ml
			
			for(k=0;k<xyzfunc.Num;k++){
				rgb.data[y*rgb.X*rgb.BAND+x*rgb.BAND+k]=orgb[k];
			}	
			fwrite(orgb,sizeof(unsigned char),rgb.BAND,fp);

		}

	}

	fclose(fp);

	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_ucvector(rgb.data,0,rgb.X*rgb.Y*rgb.BAND);
	free_dvector(StoX,0,xyzfunc.Num*wimat.BAND);
	free_dvector(StoI,0,table.RGB*wimat.BAND);
	free_dvector(irgb,0,table.RGB);
	free_ucvector(orgb,0,table.RGB);
	free_dvector(xyzfunc.data,0,xyzfunc.Num*xyzfunc.WL);
	free_dvector(dsp.XtoD,0,xyzfunc.Num*xyzfunc.Num);
	free_dvector(dsp.DtoX,0,xyzfunc.Num*xyzfunc.Num);
	free_ucvector(table.data,0,table.STEP*table.RGB);
	
}

void ChangeBAND_MSI_average(char *fn_band,char *fn_wsig,char *fn_Osig)
{
	int j,k;
	int *BAND_table;
	int cBAND,Dim;
	int START,END;

	BAND_table=DataiGet(fn_band,&cBAND,&Dim);

	MSI wmsi;//Multi Spectral Image of white	
	wmsi.fn=fn_wsig;//
	wmsi=MSIGet(wmsi.fn);


	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	char fn_g[200];
	char fn_t[200];
	sprintf(fn_t,"_%db.001",cBAND);
	ReName(msi.fn,fn_g,fn_t);

	printf("Make msi named as %s\n",fn_g);

	int x,y;
	int SX=0,EX=2048;
	int SY=0,EY=2048;


	FILE *fp;
	double *dg,d;
	unsigned short int *g;
	dg=dvector(0,cBAND);
	g=usvector(0,cBAND);


	if((fp = fopen(fn_g, "wb")) == NULL ) {
		printf("%s I[vG[\n",fn_g);
		getchar();
		exit(1);
	}


	for(y=SY;y<EY;y++){
		for(x=SX;x<EX;x++){

			for(k=0;k<cBAND;k++){
				dg[k]=0;
				START=BAND_table[k*Dim]-1;//START BAND1=0,BAND16=15
				END=BAND_table[k*Dim+1];//  END   BAND1=1,BAND16=16 
				for(j=START;j<END;j++){
					d=(double)msi.data[y*msi.X*msi.BAND+x*msi.BAND+j]/wmsi.data[y*wmsi.X*wmsi.BAND+x*wmsi.BAND+j];
					dg[k]+=d;
				}
				dg[k]/=(END-START);
				dg[k]*=SimuWhite;
				g[k]=(unsigned short int)dg[k];
			}

			fwrite(g,sizeof(unsigned short int),cBAND,fp);

		}

	}

	fclose(fp);
	
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_usvector(wmsi.data,0,wmsi.X*wmsi.Y*wmsi.BAND);


}
