// compression.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>

#include "memory_allocate.h"
#include "MSI.h"
#include "svd_v2.h"
#include "Table.h"
#include "ColorCorrect.h"
#include "SPECT.h"
#include "NaturalVision.h"
#include "kmeans.h"
#include "Dye.h"
#include "compression.h"

double* MakeKLVector(MSI *msi){
	int i,j,x,y;

	char fn_KLeigen[200];
	ReName(msi->fn,fn_KLeigen,"_KLeigen.txt");

	double *cov;//Usi[z cov[oh][oh]
	double *v,*w;//KLi[z:v[oh][oh]  KĽŗLlz:w[oh]
	cov=dvector(0,msi->BAND*msi->BAND);//Usi[z̗̈m
	v=dvector(0,msi->BAND*msi->BAND);//̈̊m
	w=dvector(0,msi->BAND);//̈̊m
	
	for(i=0;i<msi->BAND;i++){//Us̏
		for(j=0;j<msi->BAND;j++){
			cov[i*msi->BAND+j]=0;
		}
	}

	//1Xebv@KL߂
	for(y=0;y<msi->Y;y++){
		for(x=0;x<msi->X;x++){
			for(i=0;i<msi->BAND;i++){
				for(j=0;j<msi->BAND;j++){
					cov[i*msi->BAND+j]+=msi->data[y*msi->X*msi->BAND+x*msi->BAND+i]*msi->data[y*msi->X*msi->BAND+x*msi->BAND+j];
				}
			}
		}
	}

	for(i=0;i<msi->BAND;i++){
		for(j=0;j<msi->BAND;j++){
			cov[i*msi->BAND+j]/=(msi->Y*msi->X);
		}
	}

	svdcmp_zeromat1D(cov,msi->BAND,msi->BAND,w,v);//covvKLꂪi[ wɌŗLli[

	Fwrite_ProfileData(fn_KLeigen,msi->BAND,1,w);//쐬KLŗLlt@CƂďó@	w[oh]

	return v;

}

double DeterminMax(MSI *msi,double *v)//2Xebv  KLW̍ől߂鏈
{
	int x,y,i,j;

	
	double max=0,min;
	double *dg;
	dg=dvector(0,msi->BAND);
	
	for(y=0;y<msi->Y;y++){
		for(x=0;x<msi->X;x++){

			i=0;//KL1̂Ƃ̌WSfɑ΂ĒׂčőlZo
			dg[i]=0;
			for(j=0;j<msi->BAND;j++){//KL1ƃ}`XyNgMlƂ̓
				dg[i]+=v[j*msi->BAND+i]*msi->data[y*msi->X*msi->BAND+x*msi->BAND+j];
			}
			if(max<abs(dg[i]))max=abs(dg[i]);
		}
	}
	min=-max;//ŏl-maxɂ
//	printf("max=%f\tmin=%f\n",max,min);
	return max;

}

void KLmapping(MSI *msi,MSI *KL_msi,double *v,double dmax,double dmin)//3Xebv  KLW摜쐬
{
	int x,y,i,j;
	double *dg;
	dg=dvector(0,msi->BAND);

	for(y=0;y<msi->Y;y++){
		for(x=0;x<msi->X;x++){

			for(i=0;i<msi->BAND;i++){//KL̎
				dg[i]=0;
				for(j=0;j<msi->BAND;j++){//KLiƃ}`XyNgMlƂ̓
					dg[i]+=v[j*msi->BAND+i]*msi->data[y*msi->X*msi->BAND+x*msi->BAND+j];
				}

				dg[i]=(dg[i]-dmin)/(dmax-dmin);
				dg[i]*=(256*256-1);
				KL_msi->data[y*KL_msi->X*KL_msi->BAND+x*KL_msi->BAND+i]=(unsigned short int)(dg[i]);//_KL_msiz֊i[

			}
		}
	}

}


void TransformKLImgNew(char *fn_msi){

	MSI msi;//Multi Spectral Image of object	
	MSI KL_msi;//Multi Spectral Image of KL	
	msi.fn=fn_msi;//}`XyNg摜t@C
	msi=MSIGet(msi.fn);
	KL_msi=MSIinfoCOPY(&msi);

	//1Xebv KLvector ߂
	double *v;//KL vector
	char fn_KLvec[200];
	ReName(msi.fn,fn_KLvec,"_KLvec.txt");
	v=MakeKLVector(&msi);//1Xebv@KL߂
	Fwrite_ProfileData(fn_KLvec,msi.BAND,msi.BAND,v);//쐬KLmF@	@V[oh][KL̎]

	
	//2Xebv  KLW̍ől߂鏈
	double max=0,min;
	char fn_KLmax[200];
	ReName(msi.fn,fn_KLmax,"_KLmax.txt");
	
	max=DeterminMax(&msi,v);//ől߂鏈
	min=-max;//ŏl-maxɂ
	printf("max=%f\tmin=%f\n",max,min);
	Fwrite_ProfileData(fn_KLmax,1,1,&max);//쐬KLmF@	@V[oh][KL̎]


	//3Xebv  KLW摜쐬
	FILE *fp;
	char fn_KL[200];//KLW摜̃t@Ci[z
	ReName(msi.fn,fn_KL,"_KL.raw");//KLW摜̃t@C@[raw`] _
	printf("%s\n",fn_KL);

	KLmapping(&msi,&KL_msi,v,max,min);// KL 摜쐬

	if((fp = fopen(fn_KL, "wb")) == NULL ) {//rawint^o
		printf("%s I[vG[\n",fn_KL);
		getchar();
		exit(1);
	}
	fwrite(KL_msi.data,sizeof(unsigned short int),KL_msi.X*KL_msi.Y*KL_msi.BAND,fp);
	fclose(fp);

	USimgConvertRGB(fn_KL);//mF邽char^ło

	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_usvector(KL_msi.data,0,msi.X*msi.Y*msi.BAND);

}

void FileOut_TransformKLvec_max(char *fn_msi){// KL vector Ɓ@mapping 鎞̍őlZo

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_msi;//}`XyNg摜t@C
	msi=MSIGet(msi.fn);

	double *v;
	char fn_KLvec[200];
	ReName(msi.fn,fn_KLvec,"_KLvec.txt");
	v=MakeKLVector(&msi);//1Xebv@KL߂
	Fwrite_ProfileData(fn_KLvec,msi.BAND,msi.BAND,v);//쐬KLmF@	@V[oh][KL̎]

	
	//2Xebv  KLW̍ől߂鏈
	double max=0,min;
	char fn_KLmax[200];
	ReName(msi.fn,fn_KLmax,"_KLmax.txt");
	
	max=DeterminMax(&msi,v);//ől߂鏈
	min=-max;//ŏl-maxɂ
	printf("max=%f\tmin=%f\n",max,min);
	Fwrite_ProfileData(fn_KLmax,1,1,&max);//쐬KLW̍őlmF@	@V[oh][KL̎]

	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);

}

void FileOut_TransformKLImg_InputProfileData(char *fn_msi){//KL vector Ɓ@mapping鎞̍őlǂݍKL摜쐬

	int temp;//
	MSI msi;//Multi Spectral Image of object	
	MSI KL_msi;//Multi Spectral Image of KL	
	msi.fn=fn_msi;//}`XyNg摜t@C
	msi=MSIGet(msi.fn);
	KL_msi=MSIinfoCOPY(&msi);

	double *v;
	char fn_KLvec[200];
	ReName(msi.fn,fn_KLvec,"_KLvec.txt");
	v=DataGet(fn_KLvec,&temp,&temp);//1Xebv@KL̓ǂݍ݁@V[oh][KL̎]
	
	double max,min,*d;
	char fn_KLmax[200];
	ReName(msi.fn,fn_KLmax,"_KLmax.txt");
	
	d=DataGet(fn_KLmax,&temp,&temp);
	//ől
	max=d[0];
	min=-max;//ŏl-maxɂ
	printf("max=%f\tmin=%f\n",max,min);

	//3Xebv  KLW摜쐬
	FILE *fp;
	char fn_KL[200];//KLW摜̃t@Ci[z
	ReName(msi.fn,fn_KL,"_KL.raw");//KLW摜̃t@C@[raw`] _
	printf("%s\n",fn_KL);

	KLmapping(&msi,&KL_msi,v,max,min);// KL 摜쐬

	if((fp = fopen(fn_KL, "wb")) == NULL ) {//rawint^o
		printf("%s I[vG[\n",fn_KL);
		getchar();
		exit(1);
	}
	fwrite(KL_msi.data,sizeof(unsigned short int),KL_msi.X*KL_msi.Y*KL_msi.BAND,fp);
	fclose(fp);

	USimgConvertRGB(fn_KL);//mF邽char^ło

	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_usvector(KL_msi.data,0,msi.X*msi.Y*msi.BAND);

}

void PSNR_msi(char *fn_msi1,char *fn_msi2)
{
	FILE *fp;
	unsigned short int *msi1;
	unsigned short int *msi2;
	double psnr,mse;
	int SIZE1,SIZE2,Num;
	int i;
	char fnw[200];

	ReName(fn_msi2,fnw,"_psnr.txt");

	//msi1
	if((fp = fopen(fn_msi1, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn_msi1);
		getchar();
		exit(1);
	}

	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	SIZE1=ftell(fp);
	fseek(fp,  0L, SEEK_SET);

	Num=(int)SIZE1/(sizeof(unsigned short int));//f
	msi1=usvector(0,Num);
	fread(msi1,sizeof(unsigned short int),Num,fp);
	fclose(fp);

	//msi2 read 
	if((fp = fopen(fn_msi2, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn_msi2);
		getchar();
		exit(1);
	}

	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	SIZE2=ftell(fp);
	fseek(fp,  0L, SEEK_SET);

	if(SIZE1!=SIZE2){
		printf("Size of %s and size of %s is different!!\n",fn_msi1,fn_msi2);
		getchar();
		exit(1);
	}

	Num=(int)SIZE2/(sizeof(unsigned short int));//f
	msi2=usvector(0,Num);
	fread(msi2,sizeof(unsigned short int),Num,fp);
	fclose(fp);

	//PSNR vZ
	mse=0;
	for(i=0;i<Num;i++){
		mse+=(msi1[i]-msi2[i])*(msi1[i]-msi2[i]);
	}
	if(mse==0){
		printf("%s \nand %s \nis not different!! these image is same.\n",fn_msi1,fn_msi2);
		getchar();
		exit(1);
	}
	mse/=Num;
	mse=sqrt(mse);

	

	psnr=(pow(256,sizeof(unsigned short int))-1)/mse;
	psnr=20*log10(psnr);
	Fwrite_ProfileData(fnw,1,1,&psnr);

	printf("psnr=%f\n",psnr);


	free_usvector(msi1,0,Num);
	free_usvector(msi2,0,Num);

}


double* MakeResiKLVector(MSI *msi,Wie *wimat,Spec *Grass,Dye *dye,Table *MinusLog10){
		
	int i,j,x,y;

	////////////////***********             Us̍쐬                              *********************/////////////////
	int wi,wj;//ϐ
	int WDim;//g

	WDim=0;
	for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){
		WDim++;
	}

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat->WL);

	double *cov;//Usi[z cov[g][g]
	double *v,*w;//KLi[z:v[g][g]  KĽŗLlz:w[g]
	cov=dvector(0,WDim*WDim);//Usi[z̗̈m
	v=dvector(0,WDim*WDim);//̈̊m
	w=dvector(0,WDim);//̈̊m

	for(i=0;i<WDim;i++){//Us̏
		for(j=0;j<WDim;j++){
			cov[i*WDim+j]=0;
		}
	}

	for(y=0;y<msi->Y;y++){
		for(x=0;x<msi->X;x++){
			
			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//蓧ߗZo
				simSpec[i]=0;
				for(j=0;j<wimat->BAND;j++){
					simSpec[i]+=wimat->mat[i*wimat->BAND+j]*msi->data[y*msi->X*msi->BAND+x*msi->BAND+j];
				}
				simSpec[i]/=Grass->data[i];//KX̓ߗŊ
			}	

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//zx֕ϊ
				Do_MinusLog10(&simSpec[i],MinusLog10);
			}

			for(i=0;i<dye->Num;i++){//FfʎZo
				dye->vol[i]=0;
				for(j=wimat->START;j<wimat->END;j+=wimat->INTERVAL){
					dye->vol[i]+=dye->inv[dye->WL*i+j]*simSpec[j];
				}
			}

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//LBɊÂzx
				dye->LBSpec[i]=0;
				for(j=0;j<dye->Num;j++){
					dye->LBSpec[i]+=dye->spec.data[i*dye->Num+j]*dye->vol[j];
				}
			}
			
			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//LBɊÂzx
				dye->ResiSpec[i]=simSpec[i]-dye->LBSpec[i];
			}

			wi=0;
			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){
				wj=0;
				for(j=wimat->START;j<wimat->END;j+=wimat->INTERVAL){
					cov[wi*WDim+wj]+=dye->ResiSpec[i]*dye->ResiSpec[j];
					wj++;
				}
				wi++;
			}
			
		}

	}

	for(i=0;i<WDim;i++){//Us̏
		for(j=0;j<WDim;j++){
			cov[i*WDim+j]/=(msi->Y*msi->X);
		}
	}

	////////////////***********             cKL쐬                              *********************/////////////////
	svdcmp_zeromat1D(cov,WDim,WDim,w,v);//covvKLꂪi[ wɌŗLli[

	char fn_KLeigen[200];
	ReName(msi->fn,fn_KLeigen,"_ResiKLeigen.txt");

	Fwrite_ProfileData(fn_KLeigen,WDim,1,w);//쐬KLŗLlt@CƂďó@	w[g]

	return v;


}

double DeterminDyeMax(MSI *msi,Wie *wimat,Spec *Grass,Dye *dye,Table *MinusLog10){//Ffʂ̍őlZo֐

	int i,j,x,y;
	double max=-100000;

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat->WL);


	for(y=0;y<msi->Y;y++){
		for(x=0;x<msi->X;x++){

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//蓧ߗZo
				simSpec[i]=0;
				for(j=0;j<wimat->BAND;j++){
					simSpec[i]+=wimat->mat[i*wimat->BAND+j]*msi->data[y*msi->X*msi->BAND+x*msi->BAND+j];
				}
				simSpec[i]/=Grass->data[i];//KX̓ߗŊ
			}	

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//zx֕ϊ
				Do_MinusLog10(&simSpec[i],MinusLog10);
			}

			for(i=0;i<dye->Num;i++){//FfʎZo
				dye->vol[i]=0;
				for(j=wimat->START;j<wimat->END;j+=wimat->INTERVAL){
					dye->vol[i]+=dye->inv[dye->WL*i+j]*simSpec[j];
				}
				if(max<abs(dye->vol[i]))max=abs(dye->vol[i]);
			}

		}
	}

	return max;

}

void DyePlusmapping(MSI *msi,MSI *Dyemsi,Wie *wimat,Spec *Grass,Dye *dye,Table *MinusLog10,double *v,double dmax,double dmin){
		
	int i,j,k,x,y;

	int wj;//ϐ
	int WDim;//g

	WDim=0;
	for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){
		WDim++;
	}

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat->WL);

	double *dg;
	dg=dvector(0,msi->BAND);

	for(y=0;y<msi->Y;y++){
		for(x=0;x<msi->X;x++){
			
			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//蓧ߗZo
				simSpec[i]=0;
				for(j=0;j<wimat->BAND;j++){
					simSpec[i]+=wimat->mat[i*wimat->BAND+j]*msi->data[y*msi->X*msi->BAND+x*msi->BAND+j];
				}
				simSpec[i]/=Grass->data[i];//KX̓ߗŊ
			}	

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//zx֕ϊ
				Do_MinusLog10(&simSpec[i],MinusLog10);
			}

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){
			//	printf("%f\t",simSpec[i]);
			}
			//printf("\n");

			for(i=0;i<dye->Num;i++){//FfʎZo
				dye->vol[i]=0;
				for(j=wimat->START;j<wimat->END;j+=wimat->INTERVAL){
					dye->vol[i]+=dye->inv[dye->WL*i+j]*simSpec[j];
				}
			//	printf("%f\t",dye->vol[i]);
			}
		//	printf("\n");

			for(k=0;k<dye->Num;k++){// Dyemsi->data[] ́@K=0K=(dye-1) ܂ł͐Ffʂ 
				dg[k]=(dye->vol[k]-dmin)/(dmax-dmin);
				dg[k]*=(256*256-1);
				Dyemsi->data[y*Dyemsi->X*Dyemsi->BAND+x*Dyemsi->BAND+k]=(unsigned short int)(dg[k]);//_Dyemsiz֊i[
			}

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//LBɊÂzx
				dye->LBSpec[i]=0;
				for(j=0;j<dye->Num;j++){
					dye->LBSpec[i]+=dye->spec.data[i*dye->Num+j]*dye->vol[j];
				}
			}
			
			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//LBɊÂzx
				dye->ResiSpec[i]=simSpec[i]-dye->LBSpec[i];
			}

			for(k=dye->Num;k<msi->BAND;k++){// Dyemsi->data[] ́@K=dye K=MSIBAND ܂ł͎ĉP
				dg[k]=0;
				wj=0;
				for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//LBɊÂzx
					dg[k]+=dye->ResiSpec[i]*v[wj*WDim+(k-dye->Num)];
					wj++;
				}
			//	printf("%f\t",dg[k]);

				dg[k]=(dg[k]-dmin)/(dmax-dmin);
				dg[k]*=(256*256-1);
				Dyemsi->data[y*Dyemsi->X*Dyemsi->BAND+x*Dyemsi->BAND+k]=(unsigned short int)(dg[k]);//_Dyemsiz֊i[
			}
		//	printf("\n");

		}

	}


}

void FileOut_DyeKLvec_max(char *fn_sys,char *fn_wsig,char *fn_Osig)
{
	int i;
	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	//::::::::::::::::     TvOԊuwimat->INTERVAL̎̔g   ::::::::::::::::::::::::::::::::::::::::
	int WDim;//g
	WDim=0;
	for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
		WDim++;
	}

	//:::::::::::::::       cKLZo                 ::::::::::::::::::::::::::::::::::::::::::::::::::
	double *v;//cKL
	v=MakeResiKLVector(&msi,&wimat,&Grass,&dye,&MinusLog10);

	char fn_KLvec[200];
	ReName(msi.fn,fn_KLvec,"_ResiKLvec.txt");
	Fwrite_ProfileData(fn_KLvec,WDim,WDim,v);//쐬KLŗLlt@CƂďó@	w[g]

	//:::::::::::::::       }bsO鎞̍őlZo                 ::::::::::::::::::::::::::::::::::::::::::::::::::
	double max,min;
	char fn_KLmax[200];
	ReName(msi.fn,fn_KLmax,"_ResiKLmax.txt");
	
	max=DeterminDyeMax(&msi,&wimat,&Grass,&dye,&MinusLog10);
	min=-max;

	printf("max=%f\tmin=%f\n",max,min);
	Fwrite_ProfileData(fn_KLmax,1,1,&max);//쐬KLW̍őlmF@	@V[oh][KL̎]

	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_dvector(simSpec,0,wimat.WL);

}

void Encode_DyePlusResiImg_InputProfileData(char *fn_sys,char *fn_wsig,char *fn_Osig)
{
	int temp;
	int i;
	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	MSI Dyemsi;//Multi Spectral Image of KL	
	Dyemsi=MSIinfoCOPY(&msi);

	//::::::::::::::::     TvOԊuwimat->INTERVAL̎̔g   ::::::::::::::::::::::::::::::::::::::::
	int WDim;//g
	WDim=0;
	for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
		WDim++;
	}

	//:::::::::::::::       cKLǂݍ               ::::::::::::::::::::::::::::::::::::::::::::::::::
	double *v;//cKL
	//v=MakeResiKLVector(&msi,&wimat,&Grass,&dye,&MinusLog10);
	char fn_KLvec[200];
	ReName(msi.fn,fn_KLvec,"_ResiKLvec.txt");
	v=DataGet(fn_KLvec,&temp,&temp);//1Xebv@KL̓ǂݍ݁@V[oh][KL̎]
	if(WDim!=temp){
		printf("Dimension of wavelength is different between input file and current setting !!\n");
		getchar();
		exit(1);
	}

	//:::::::::::::::       }bsO鎞̍őlǂݍ          ::::::::::::::::::::::::::::::::::::::::::::::::::
	double max,min,*d;
	char fn_KLmax[200];
	ReName(msi.fn,fn_KLmax,"_ResiKLmax.txt");
	d=DataGet(fn_KLmax,&temp,&temp);	

	//ől
	max=d[0];
	min=-max;//ŏl-maxɂ
	printf("max=%f\tmin=%f\n",max,min);


	//:::::::::::::::       Dye Plus Residual image Zo      ::::::::::::::::::::::::::::::::::::::::::::::::::
	FILE *fp;
	char fn_DyePls[200];//KLW摜̃t@Ci[z
	ReName(msi.fn,fn_DyePls,"_DyePlus.raw");//KLW摜̃t@C@[raw`] _
	printf("%s\n",fn_DyePls);

	DyePlusmapping(&msi,&Dyemsi,&wimat,&Grass,&dye,&MinusLog10,v,max,min);// DYE Plus 摜쐬

	if((fp = fopen(fn_DyePls, "wb")) == NULL ) {//rawint^o
		printf("%s I[vG[\n",fn_DyePls);
		getchar();
		exit(1);
	}
	fwrite(Dyemsi.data,sizeof(unsigned short int),Dyemsi.X*Dyemsi.Y*Dyemsi.BAND,fp);
	fclose(fp);
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_usvector(Dyemsi.data,0,Dyemsi.X*Dyemsi.Y*Dyemsi.BAND);
	free_dvector(simSpec,0,wimat.WL);


}

void DyePlusDecodemapping(MSI *Dyemsi,MSI *dcmsi,Wie *wimat,Spec *Grass,Dye *dye,Table *Minus10Power,double *v,double dmax,double dmin){//DyePlus摜Zo֐

	int i;
	int y,x,j,k;
	int wj;

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat->WL);

	//::::::::::::::::     TvOԊuwimat->INTERVAL̎̔g   ::::::::::::::::::::::::::::::::::::::::
	int WDim;//g
	WDim=0;
	for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){
		WDim++;
	}

	double *dg;
	dg=dvector(0,Dyemsi->BAND);

	for(y=0;y<Dyemsi->Y;y++){
		for(x=0;x<Dyemsi->X;x++){

			for(k=0;k<dye->Num;k++){// Dyemsi->data[] ́@K=0K=(dye-1) ܂ł͐Ffʂ 
				dye->vol[k]=((double)Dyemsi->data[y*Dyemsi->X*Dyemsi->BAND+x*Dyemsi->BAND+k]/(256*256-1))*(dmax-dmin);
				dye->vol[k]+=dmin;//double^̐Ffʂ֕ϊ
			}

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//LBɊÂzx
				dye->LBSpec[i]=0;
				for(j=0;j<dye->Num;j++){
					dye->LBSpec[i]+=dye->spec.data[i*dye->Num+j]*dye->vol[j];
				}
			}

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){
				dye->ResiSpec[i]=0;
			}

			for(k=dye->Num;k<Dyemsi->BAND;k++){
				dg[k]=((double)Dyemsi->data[y*Dyemsi->X*Dyemsi->BAND+x*Dyemsi->BAND+k]/(256*256-1))*(dmax-dmin);
				dg[k]+=dmin;//double^KLW֕ϊ

				wj=0;
				for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){
					dye->ResiSpec[i]+=dg[k]*v[wj*WDim+(k-dye->Num)];
					wj++;
				}
			}

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//LBɊÂzx
				simSpec[i]=dye->ResiSpec[i]+dye->LBSpec[i];
			}

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//ߗ֕ϊ
				Do_Minus10Power(&simSpec[i],Minus10Power);
				simSpec[i]*=Grass->data[i];//KX̓ߗ
			}

			for(k=0;k<dcmsi->BAND;k++){
				dg[k]=0;
				for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//蓧ߗZo
					dg[k]+=wimat->tr_H[i*wimat->BAND+k]*simSpec[i];
				}
				dcmsi->data[y*dcmsi->X*dcmsi->BAND+x*dcmsi->BAND+k]=(unsigned short int)dg[k];
			}

		}

	}


}

void Decode_DyePlusResiImg_InputProfileData(char *fn_sys,char *fn_wsig,char *fn_dyePLUS,char *fn_KLvec,char *fn_KLmax)
{
	int temp;
	int i;

	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	MSI Dyemsi;//Multi Spectral Image of object	
	Dyemsi.fn=fn_dyePLUS;//"..\\DATA\\HE3.001";
	Dyemsi=MSIGet(Dyemsi.fn);

	MSI dcmsi;//Multi Spectral Image of KL	
	dcmsi=MSIinfoCOPY(&Dyemsi);

	//::::::::::::::::     TvOԊuwimat->INTERVAL̎̔g   ::::::::::::::::::::::::::::::::::::::::
	int WDim;//g
	WDim=0;
	for(i=wimat.START;i<wimat.END;i+=wimat.INTERVAL){
		WDim++;
	}

	//:::::::::::::::       cKLǂݍ               ::::::::::::::::::::::::::::::::::::::::::::::::::
	double *v;//cKL
	//v=MakeResiKLVector(&msi,&wimat,&Grass,&dye,&MinusLog10);
//	char fn_KLvec[200];
//	ReName(msi.fn,fn_KLvec,"_ResiKLvec.txt");
	v=DataGet(fn_KLvec,&temp,&temp);//1Xebv@KL̓ǂݍ݁@V[oh][KL̎]
	if(WDim!=temp){
		printf("Dimension of wavelength is different between input file and current setting !!\n");
		getchar();
		exit(1);
	}

	//:::::::::::::::       }bsO鎞̍őlǂݍ          ::::::::::::::::::::::::::::::::::::::::::::::::::
	double max,min,*d;
	//char fn_KLmax[200];
	//ReName(msi.fn,fn_KLmax,"_ResiKLmax.txt");
	d=DataGet(fn_KLmax,&temp,&temp);	

	//ől
	max=d[0];
	min=-max;//ŏl-maxɂ
	printf("max=%f\tmin=%f\n",max,min);


	//:::::::::::::::       Dye Plus Residual @Decode image Zo      ::::::::::::::::::::::::::::::::::::::::::::::::::
	FILE *fp;
	char fn_dcmsi[200];//KLW摜̃t@Ci[z
	ReName(Dyemsi.fn,fn_dcmsi,"_Decode.raw");//KLW摜̃t@C@[raw`] _
	printf("%s\n",fn_dcmsi);

	DyePlusDecodemapping(&Dyemsi,&dcmsi,&wimat,&Grass,&dye,&Minus10Power,v,max,min);
	
	if((fp = fopen(fn_dcmsi, "wb")) == NULL ) {//rawint^o
		printf("%s I[vG[\n",fn_dcmsi);
		getchar();
		exit(1);
	}
	fwrite(dcmsi.data,sizeof(unsigned short int),dcmsi.X*dcmsi.Y*dcmsi.BAND,fp);
	fclose(fp);

	USimgConvertRGB(fn_dcmsi);
	
	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(dcmsi.data,0,dcmsi.X*dcmsi.Y*dcmsi.BAND);
	free_usvector(Dyemsi.data,0,Dyemsi.X*Dyemsi.Y*Dyemsi.BAND);
	free_dvector(simSpec,0,wimat.WL);


}



void MakeMsiResi_Max(MSI *msi,Wie *wimat,Spec *Grass,Dye *dye,Table *MinusLog10,Table *Minus10Power){
		
	int i,j,x,y,k;

	double *dg,*rg;
	dg=dvector(0,msi->BAND);
	rg=dvector(0,msi->BAND);

	unsigned short int *ug;
	ug=usvector(0,msi->BAND);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat->WL);

	for(y=0;y<msi->Y;y++){
		for(x=0;x<msi->X;x++){
			
			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//蓧ߗZo
				simSpec[i]=0;
				for(j=0;j<wimat->BAND;j++){
					simSpec[i]+=wimat->mat[i*wimat->BAND+j]*msi->data[y*msi->X*msi->BAND+x*msi->BAND+j];
				}
				simSpec[i]/=Grass->data[i];//KX̓ߗŊ
			}	

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//zx֕ϊ
				Do_MinusLog10(&simSpec[i],MinusLog10);
			}

			for(i=0;i<dye->Num;i++){//FfʎZo
				dye->vol[i]=0;
				for(j=wimat->START;j<wimat->END;j+=wimat->INTERVAL){
					dye->vol[i]+=dye->inv[dye->WL*i+j]*simSpec[j];
				}
			}

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//LBɊÂzx
				dye->LBSpec[i]=0;
				for(j=0;j<dye->Num;j++){
					dye->LBSpec[i]+=dye->spec.data[i*dye->Num+j]*dye->vol[j];
				}
			}

			for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//ߗ֕ϊ
				Do_Minus10Power(&dye->LBSpec[i],Minus10Power);
				dye->LBSpec[i]*=Grass->data[i];//KX̓ߗ
			}

			for(k=0;k<msi->BAND;k++){
				dg[k]=0;
				for(i=wimat->START;i<wimat->END;i+=wimat->INTERVAL){//蓧ߗZo
					dg[k]+=wimat->tr_H[i*wimat->BAND+k]*dye->LBSpec[i];
				}
				ug[k]=(unsigned short int)dg[k];
				//dcmsi->data[y*dcmsi->X*dcmsi->BAND+x*dcmsi->BAND+k]=(unsigned short int)dg[k];
			}

			for(k=0;k<msi->BAND;k++){
				rg[k]=msi->data[y*msi->X*msi->BAND+x*msi->BAND+j]-ug[k];
			}

			
		}

	}

}

void FileOut_Dye_MSIRESI_max(char *fn_sys,char *fn_wsig,char *fn_Osig)
{
	Wie wimat;
	wimat=Do_Wmat(fn_sys,fn_wsig);//make wieners

	Dye dye;
	Spec	Grass;//KX̓ߗ
	
	char	fn_dye[]="..\\DATA\\trans_upmc_re_401_ver3.spec";
	char	fn_grass[]="..\\DATA\\glass_931_401_ver3.spec";

	Table	MinusLog10,Minus10Power;
	MinusLog10=MinusLog10Table();
	Minus10Power=Minus10PowerTable();

	dye=Do_Dmat(fn_dye,&wimat,&MinusLog10);
	Grass=SpecGet(fn_grass);

	double *simSpec;////XyNg
	simSpec=dvector(0,wimat.WL);

	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_Osig;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	//:::::::::::::::       }bsO鎞̍őlZo                 ::::::::::::::::::::::::::::::::::::::::::::::::::
	double max,min;
	char fn_KLmax[200];
	ReName(msi.fn,fn_KLmax,"_ResiKLmax.txt");

	MakeMsiResi_Max(&msi,&wimat,&Grass,&dye,&MinusLog10,&Minus10Power);


	max=DeterminDyeMax(&msi,&wimat,&Grass,&dye,&MinusLog10);
	min=-max;

	printf("max=%f\tmin=%f\n",max,min);
	Fwrite_ProfileData(fn_KLmax,1,1,&max);//쐬KLW̍őlmF@	@V[oh][KL̎]

	free_dvector(wimat.mat,0,wimat.WL*wimat.BAND);
	free_dvector(wimat.tr_H,0,wimat.WL*wimat.BAND);
	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);
	free_dvector(simSpec,0,wimat.WL);

}


void Dyeplus_Division(char *fn,int DYEBAND)
{
	FILE *fp,*fp2;
	unsigned short int *ug;
	unsigned short int *udye;
	unsigned short int *uresi;
	int DATASIZE;
	int SIZE;//f
	int BAND;//͂摜̃oh
	int RESIBAND;//c摜̃oh
	int X=2048;
	int Y=2048;

	int x,y,k;

	char fndye[200];
	char fnresi[200];

	ReName(fn,fndye,"_dye.raw");
	printf("%s\n",fndye);

	ReName(fn,fnresi,"_resi.raw");
	printf("%s\n",fnresi);
	
	if((fp = fopen(fn, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn);
		getchar();
		exit(1);
	}

	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	DATASIZE=ftell(fp);
	fseek(fp,  0L, SEEK_SET);
	SIZE=DATASIZE/sizeof(unsigned short int);
	BAND=(int)SIZE/(X*Y);
	RESIBAND=BAND-DYEBAND;

	udye=usvector(0,DYEBAND);
	uresi=usvector(0,RESIBAND);
	ug=usvector(0,SIZE);

	fread(ug,sizeof(unsigned short int),SIZE,fp);
	fclose(fp);

	if((fp = fopen(fndye, "wb")) == NULL ) {
		printf("%s I[vG[\n",fndye);
		getchar();
		exit(1);
	}

	if((fp2 = fopen(fnresi, "wb")) == NULL ) {
		printf("%s I[vG[\n",fnresi);
		getchar();
		exit(1);
	}

	for(y=0;y<Y;y++){
		for(x=0;x<X;x++){
			for(k=0;k<DYEBAND;k++){
				udye[k]=ug[y*X*BAND+x*BAND+k];
			}
			for(k=DYEBAND;k<BAND;k++){
				uresi[k-DYEBAND]=ug[y*X*BAND+x*BAND+k];
			}

			fwrite(udye,sizeof(unsigned short int),DYEBAND,fp);
			fwrite(uresi,sizeof(unsigned short int),RESIBAND,fp2);
		}
	}

	fclose(fp);
	fclose(fp2);	

	free_usvector(ug,0,SIZE);

	USimgConvertRGB(fndye);
	USimgConvertRGB(fnresi);

}

void Dyeplus_JOINT(char *fndye,char *fnresi)// ŏɐFfʉ摜t@C@Ɂ@c摜
{
	FILE *fp;
	unsigned short int *ug;
	unsigned short int *udye;
	unsigned short int *uresi;
	int DYEBAND;//Ffʉ摜̃oh
	int DATASIZE;
	int DSIZE;//Ffʉ摜̑f
	int RSIZE;//RESI摜̑f

	int BAND;//͂摜̃oh
	int RESIBAND;//c摜̃oh
	int X=2048;
	int Y=2048;

	int x,y,k;

	char fndye_resi[200];
	NameJoint(fndye,fnresi,fndye_resi,".raw");
	printf("%s\n",fndye_resi);

	//  :::::::::::::::::::    Ffʉ摜t@Cǂݍ݁@:::::::::::::::::::::::::::
	if((fp = fopen(fndye, "rb")) == NULL ) {
		printf("%s I[vG[\n",fndye);
		getchar();
		exit(1);
	}

	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	DATASIZE=ftell(fp);
	fseek(fp,  0L, SEEK_SET);
	DSIZE=DATASIZE/sizeof(unsigned short int);//Ffʉ摜̑f
	DYEBAND=(int)DSIZE/(X*Y);//Ffʉ摜̃oh

	udye=usvector(0,DSIZE);//zm
	fread(udye,sizeof(unsigned short int),DSIZE,fp);
	fclose(fp);


	//  :::::::::::::::::::    c摜t@Cǂݍ݁@:::::::::::::::::::::::::::
	if((fp = fopen(fnresi, "rb")) == NULL ) {
		printf("%s I[vG[\n",fnresi);
		getchar();
		exit(1);
	}

	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	DATASIZE=ftell(fp);
	fseek(fp,  0L, SEEK_SET);
	RSIZE=DATASIZE/sizeof(unsigned short int);//RESI摜̑f
	RESIBAND=(int)RSIZE/(X*Y);//RESI摜̃oh

	uresi=usvector(0,RSIZE);//zm
	fread(uresi,sizeof(unsigned short int),RSIZE,fp);
	fclose(fp);

	BAND=RESIBAND+DYEBAND;
	printf("oh@@%d\n",BAND);

	ug=usvector(0,BAND);//zm

	//  :::::::::::::::::::    t@CZo@:::::::::::::::::::::::::::


	if((fp = fopen(fndye_resi, "wb")) == NULL ) {
		printf("%s I[vG[\n",fndye_resi);
		getchar();
		exit(1);
	}

	for(y=0;y<Y;y++){
		for(x=0;x<X;x++){
			for(k=0;k<DYEBAND;k++){
				ug[k]=udye[y*X*DYEBAND+x*DYEBAND+k];
			}
			for(k=0;k<RESIBAND;k++){
				ug[k+DYEBAND]=uresi[y*X*RESIBAND+x*RESIBAND+k];
			}

			fwrite(ug,sizeof(unsigned short int),BAND,fp);
			
		}
	}

	fclose(fp);


	free_usvector(ug,0,BAND);
	free_usvector(udye,0,DSIZE);
	free_usvector(uresi,0,RSIZE);

	USimgConvertRGB(fndye_resi);

}

