// MixedRadixFFT.cpp : R\[ AvP[ṼGg |Cg`܂B
//

//#include "stdafx.h"
//#include "MFFT.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "Palam.h"

#if !defined(HOGE_X)
#define HOGE_X
#include "FFT.h"
#endif

/*

  *   SingletonĂASYɊÂFFT
  *   29ȏ̑ff[^̈Ɋ܂܂ꍇ͓Kps\

 *   R. C. Singleton, An algorithm for computing the mixed radix fast
 *   Fourier transform 
 *
 *	IEEE Trans. Audio Electroacoust., vol. AU-17, pp. 93-10, June 1969.
 *   Some features are:


*/

/**************************************************************************

	Javier Soley, Ph. D,   FJSOLEY @UCRVM2.BITNET
	Escuela de F!sica y Centro de Investigaciones Geof!sicas
	Universidad de Costa Rica

***************************************************************************/

/*	Computes the DISCRETE FOURIER TRANSFORM of very long data series.
 *   Restriction: the data has to fit in conventional memory.
 *
 *   Compile in compact or large models ===> Pointers must be FAR
 *   Two huge pointers are used to access the real and imaginary
 *   parts of the transform without 64k wrap around. 
 *
 *   This functions are translations from the fortran program in
 *
 *   R. C. Singleton, An algorithm for computing the mixed radix fast
 *   Fourier transform 
 *
 *	IEEE Trans. Audio Electroacoust., vol. AU-17, pp. 93-10, June 1969.
 *   Some features are:
 *
 *		1-) Accepts an order of transform that can be factored not only
 *		    in prime factors such 2 and 4, but also including odd factors
 *		    as 3, 5, 7, 11, etc.
 *		2-) Generates sines and cosines recursively and includes
 *		    corrections for truncation errors.
 *		3-) The original subroutine accepts multivariate data. This 
 *			translation does not implement that option (because I
 *			do not needed right now).
 *
 *	Singleton wrote his subroutine in Fortran and in such a way that it 
 *	could be ported allmost directly to assembly language. I transcribed
 *   it to C with little effort to make it structured. So I apologize to
 *   all those C purists out there!!!!!!!!
 *
 */

				/*  Version 2.0 March/30/92 */
/* Includes */

///*#include <stdlib.h>*/
//#include <stdio.h>
//#include <math.h>
//
///* Defines */
//#ifndef M_PI
//#define	M_PI	3.14159265358979323846
//#define	M_PI_2		1.57079632679489661923
//#endif
//
//#define	TWO_PI	((double)2.0 * M_PI)
//#define   MAXF  23
//#define   MAXP  1000//before 209
//
//#define   double     double   /* or float or long double */	
//#define   MY_TYPE          /* huge or far if data fits in two 64 K segments */
//
//
/* Globals */

long nn_mr, m_mr, flag_mr, jf_mr, jc_mr, kspan, ks_mr, kt_mr, nt_mr, kk_mr, i_mr;
double   c72_mr, s72_mr, s120_mr, cd_mr, sd_mr, rad_mr, radf_mr, at_mr[23], bt_mr[23];
long nfac[23];   
int inc_mr;
long np_mr[MAXP];


/* The functions */

void radix_2( double *a, double *b)
{ long k1, k2;
  double ak, bk, c1, s1;
	kspan >>= 1;
	k1 = kspan +2;

	do {
		do  {
		  k2 = kk_mr + kspan;
		  ak = a[k2-1];
		  bk = b[k2-1];
		  a[k2-1] = a[kk_mr-1] -ak;
		  b[k2-1] = b[kk_mr-1] -bk;
		  a[kk_mr-1] += ak;
		  b[kk_mr-1] += bk;
		  kk_mr = k2 + kspan;
		} while ( kk_mr <= nn_mr);
	   kk_mr = kk_mr - nn_mr;
	} while ( kk_mr <= jc_mr);


	if ( kk_mr > kspan) flag_mr = 1; 
	else
	{
	do {
		c1 = 1.0 - cd_mr;
		s1 = sd_mr;
		do {
		    do  {
				do {
					k2 = kk_mr + kspan;
					ak = a[kk_mr-1]- a[k2-1];
					bk = b[kk_mr-1]- b[k2-1];
					a[kk_mr-1] += a[k2-1];
					b[kk_mr-1] += b[k2-1];
					a[k2-1]  = c1*ak - s1*bk;
					b[k2-1]  = s1*ak + c1*bk;
					kk_mr = k2 + kspan;
				} while ( kk_mr < nt_mr );
		    k2 = kk_mr - nt_mr;
		    c1 = -c1;
		    kk_mr = k1 - k2;
		    } while ( kk_mr > k2 );
		ak = c1- (cd_mr*c1+sd_mr*s1);
		s1 = (sd_mr*c1-cd_mr*s1) +s1;

	 /***** Compensate for truncation errors   *****/

		c1 = 0.5/(ak*ak+s1*s1)+0.5;
		s1 *= c1;
		c1 *= ak;
		kk_mr += jc_mr;
		} while ( kk_mr < k2);
		k1 = k1 + inc_mr + inc_mr;
		kk_mr = (k1- kspan) /2 + jc_mr;
	   } while ( kk_mr <= jc_mr + jc_mr );
    }
}

void radix_4(int  isn,double *a,double *b)
{
	long	k1, k2, k3;
	double  akp, akm, ajm, ajp, bkm, bkp, bjm, bjp;
	double  c1, s1, c2, s2, c3, s3;
	kspan /= 4;
cuatro_1: 
	c1 = 1.0;
	s1 = 0;
	do {
		do {
			do {
				k1  =  kk_mr + kspan;
				k2  =  k1 + kspan;
				k3  =  k2 + kspan;
				akp =  a[kk_mr-1] + a[k2-1];
				akm =  a[kk_mr-1] - a[k2-1];
				ajp =  a[ k1-1] + a[k3-1];
				ajm =  a[ k1-1] - a[k3-1];
				a[kk_mr-1] = akp + ajp;
				ajp = akp - ajp;
				bkp = b[kk_mr-1] + b[k2-1];
				bkm = b[kk_mr-1] - b[k2-1];
				bjp = b[k1-1] + b[k3-1];
				bjm = b[k1-1] - b[k3-1];
				b[kk_mr-1] = bkp + bjp;
				bjp = bkp - bjp;
				if ( isn < 0) goto cuatro_5;
				akp = akm - bjm;
				akm = akm + bjm;
				bkp = bkm + ajm;
				bkm = bkm - ajm;
				if (s1 == 0.0) goto cuatro_6;
	cuatro_3:		a[ k1-1] = akp*c1 - bkp*s1;
				b[ k1-1] = akp*s1 + bkp*c1;
				a[ k2-1] = ajp*c2 - bjp*s2;
				b[ k2-1] = ajp*s2 + bjp*c2;
				a[ k3-1] = akm*c3 - bkm*s3;
				b[ k3-1] = akm*s3 + bkm*c3;
				kk_mr = k3 + kspan;
				}  while ( kk_mr <= nt_mr);
				
	cuatro_4: 
		c2 = c1 - (cd_mr*c1 + sd_mr*s1);
		s1 = (sd_mr*c1 - cd_mr*s1) + s1;

    /***** Compensate for truncation errors *****/

		c1 = 0.5 / (c2*c2 + s1*s1) +0.5;
		s1 = c1 * s1;
		c1 = c1 * c2;
		c2 = c1*c1 - s1*s1;
		s2 = 2.0 * c1 *s1;
		c3 = c2*c1 - s2*s1;
		s3 = c2*s1 + s2*c1;
		kk_mr = kk_mr -nt_mr + jc_mr;
		} while ( kk_mr <= kspan);
		
	kk_mr = kk_mr - kspan + inc_mr;
	if ( kk_mr <= jc_mr)  goto cuatro_1;
	if ( kspan == jc_mr)  flag_mr =1;
	goto out;
cuatro_5:
	akp = akm + bjm;
	akm = akm - bjm;
	bkp = bkm - ajm;
	bkm = bkm + ajm;
	if (s1 != 0.0) goto cuatro_3;
cuatro_6:
	a[k1-1] = akp;
	b[k1-1] = bkp;
	b[k2-1] = bjp;
	a[k2-1] = ajp;
	a[k3-1] = akm;
	b[k3-1] = bkm;
	kk_mr = k3 + kspan;
	} while ( kk_mr <= nt_mr);
	goto cuatro_4;
out: 
	s1 = s1 + 0.0;
}




	/* Find prime factors of n */

void fac_des(long n )
{
	long k, j, jj;
	k  = n;
	m_mr = 0;
	while ( k-(k / 16)*16 == 0 ) {
		m_mr++;
		nfac[m_mr-1] = 4;
		k /= 16;
	} 
	j  = 3;
	jj = 9;
	do {
		 while (k % jj == 0) {
			 m_mr++;
			 nfac[m_mr-1] = j;
			 k /= jj;
		 }
	j += 2;
	jj = j * j;
	} while ( jj <= k);
	if (k <= 4) {
		kt_mr = m_mr;
		nfac[m_mr] = k;
		if (k != 1) m_mr++;
	}
	else {
		if (k-(k / 4)*4 == 0) {
			m_mr++;
			nfac[m_mr-1] = 2;
			k /= 4;
		}
		kt_mr = m_mr;
		j = 2;
		do {
			if (k % j == 0 ) {
				m_mr++;
				nfac[m_mr-1] = j;
				k /= j;
			}
		j = ((j+1)/ 2)*2 + 1;
		} while ( j <= k);
	}
	if (kt_mr != 0) {
		j = kt_mr;
		do {
		   m_mr++;
		   nfac[m_mr-1] = nfac[j-1];
		   j--;
		} while ( j != 0);
	}
}    

    /* Permute the results to normal order  */


void permute(long ntot,long n, double *a, double *b)
{
	long  k, j, k1, k2, k3, kspnn, maxf;

	double ak, bk;
	long  ii, jj;
	maxf = MAXF;
	np_mr[0] = ks_mr;
	if (kt_mr != 0) {
		k = kt_mr +kt_mr +1;
		if (m_mr < k) k--;
		j = 1;
		np_mr[k] = jc_mr;
		do {
			np_mr[j]   = np_mr[j-1] / nfac[j-1];
			np_mr[k-1] = np_mr[k]   * nfac[j-1];
			j++;
			k--;
		} while (j < k);
		k3 = np_mr[k];   
		kspan = np_mr[1];
		kk_mr = jc_mr+1;
		k2 = kspan + 1;  
		j = 1;

		/***** Permutation of one dimensional transform *****/

		if (n == ntot) {
			do {
				do {
					ak      = a[kk_mr-1];
					a[kk_mr-1] = a[k2-1];
					a[k2-1] = ak;
					bk      = b[kk_mr-1];
					b[kk_mr-1] = b[k2-1];
					b[k2-1] = bk;
					kk_mr     += inc_mr;
					k2     += kspan;
				} while ( k2 < ks_mr);
ocho_30:  		do {
				k2 -= np_mr[j-1];
				j++;
				k2 += np_mr[j];
				} while (k2 > np_mr[j-1]);
				j = 1;
ocho_40:  		j = j + 0;
			} while (kk_mr < k2);
			kk_mr += inc_mr;
			k2 += kspan;
			if (k2 < ks_mr)  goto ocho_40;
			if (kk_mr < ks_mr)  goto ocho_30;
			jc_mr = k3;
		}
		else {        /* Permutation for multiple transform  */
ocho_50:
			do {
				do {
					k = kk_mr + jc_mr;
					do {
						ak = a[kk_mr-1];	
						a[kk_mr-1] = a[k2-1];
						a[k2-1] = ak;							
						bk = b[kk_mr-1];
						b[kk_mr-1] = b[k2-1];
						b[k2-1] = bk;
						kk_mr += inc_mr;
						k2 += inc_mr;
					} while ( kk_mr < k);
					kk_mr = kk_mr + ks_mr - jc_mr;
					k2 = k2 + ks_mr - jc_mr;
				} while (kk_mr < nt_mr);
				k2 = k2 - nt_mr + kspan;
				kk_mr = kk_mr - nt_mr + jc_mr;
			} while (k2 < ks_mr);
			do {
				do {
					k2 -= np_mr[j-1];
					j++;
					k2 += np_mr[j];
				} while (k2 > np_mr[j-1]);
				j =1;
				do {
					if ( kk_mr < k2 ) goto ocho_50;
					kk_mr +=jc_mr;
					k2 += kspan;
				} while (k2 < ks_mr);
			} while (kk_mr < ks_mr);
			jc_mr = k3;
		}
	}

	if ( (2*kt_mr +1) < m_mr) {
		kspnn = np_mr[kt_mr];
		/* Permutation of square-free factors of n */
		j = m_mr - kt_mr;
		nfac[j] = 1;
		do {
			nfac[j-1] *= nfac[j];
			j--;
		} while (j != kt_mr);
		kt_mr++;
		nn_mr = nfac[kt_mr-1] -1;
		if (nn_mr > MAXP) {
			printf("product of square free factors exceeds allowed limit\n");
			getchar();
			exit(2);
		}
		jj =0;
		j=0;
		goto nueve_06;
nueve_02:
		jj -= k2;
		k2 = kk_mr;
		k++;
		kk_mr = nfac[k-1];
		do {
			jj += kk_mr;
			if ( jj >= k2 ) goto nueve_02;
			np_mr[j-1] = jj;
nueve_06:
			k2 = nfac[kt_mr-1];
			k = kt_mr+1;
			kk_mr = nfac[k-1];
			j++;
		} while (j <= nn_mr);
		/* determine the permutation cycles  of length greater then 1 */
		j =0;
		goto nueve_14;
		do {
			do {		
				k = kk_mr;
				kk_mr = np_mr[k-1];
				np_mr[k-1] = -kk_mr;
			} while ( kk_mr != j);
			k3 = kk_mr;
nueve_14:
			do {
				j++;
				kk_mr = np_mr[j-1];
			} while (kk_mr <0);
		} while ( kk_mr != j);
		np_mr[j-1] = -j;
		if (j != nn_mr) goto nueve_14;
		maxf *= inc_mr;				
		/* Reorder a and b following the permutation cycles */
		goto nueve_50;
		do {
			do {
				do { j--;} while (np_mr[j-1] <0);
				jj = jc_mr;
				do {
					kspan = jj;
					if ( jj > maxf) kspan = maxf;
					jj -= kspan;
					k = np_mr[j-1];	
					kk_mr = jc_mr*k + ii + jj;
					k1 = kk_mr + kspan;
					k2 =0;
					do {
						k2++;
						at_mr[k2-1] = a[k1-1];
						bt_mr[k2-1] = b[k1-1];
						k1 -= inc_mr;
					} while (k1 != kk_mr);
					do {
						k1 = kk_mr + kspan;
						k2 = k1 - jc_mr*(k + np_mr[k-1]);
						k = -np_mr[k-1];
						do {
							a[k1-1] = a[k2-1];
							b[k1-1] = b[k2-1];
							k1 -= inc_mr;
							k2 -= inc_mr;
						} while (k1 != kk_mr);
						kk_mr = k2;
					} while ( k != j);
					k1 = kk_mr + kspan;
					k2 = 0;
					do {
						k2++;
						a[k1-1] = at_mr[k2-1];
						b[k1-1] = bt_mr[k2-1];
						k1 -= inc_mr;
					} while ( k1 != kk_mr);							
				} while ( jj != 0 );
			} while (j !=1);
nueve_50:
			j = k3+1;
			nt_mr -= kspnn;
			ii = nt_mr - inc_mr +1;
		} while ( nt_mr >= 0);
		k = k + 0;
	}
}


/**************************************************************************
Functions for prime factor radix
***************************************************************************/

void radix_3(double *a, double *b)
{
	long	k1, k2;
	double  ak, bk, aj, bj;

	do {
		do {
			
			k1 = kk_mr + kspan;
			k2 = k1+ kspan;
			ak = a[kk_mr-1];
			bk = b[kk_mr-1];
			aj = a[k1-1] + a[k2-1];
			bj = b[k1-1] + b[k2-1];
			a[kk_mr-1] = ak + aj;
			b[kk_mr-1] = bk + bj;
			ak = -0.5*aj + ak;
			bk = -0.5*bj + bk;
			aj = (a[k1-1]-a[k2-1])*s120_mr;
			bj = (b[k1-1]-b[k2-1])*s120_mr;
			a[k1-1] = ak - bj;
			b[k1-1] = bk + aj;
			a[k2-1] = ak + bj;
			b[k2-1] = bk - aj;
			kk_mr = k2 + kspan;
		} while ( kk_mr < nn_mr);
		kk_mr = kk_mr - nn_mr;
	} while ( kk_mr <= kspan);
}
	
void radix_5(double *a,double *b)
{
	long k1, k2, k3, k4;
	double ak, aj, bk, bj, akp, akm, ajm, ajp, aa, bkp, bkm, bjm, bjp, bb;
	double c2, s2;
	c2 = c72_mr*c72_mr - s72_mr*s72_mr;
	s2 = 2 * c72_mr * s72_mr;
	do {
		do {
			k1 = kk_mr + kspan;
			k2 = k1 + kspan;
			k3 = k2 + kspan;
			k4 = k3 + kspan;
			akp = a[k1-1] + a[k4-1];
			akm = a[k1-1] - a[k4-1];
			bkp = b[k1-1] + b[k4-1];
			bkm = b[k1-1] - b[k4-1];
			ajp = a[k2-1] + a[k3-1];
			ajm = a[k2-1] - a[k3-1];
			bjp = b[k2-1] + b[k3-1];
			bjm = b[k2-1] - b[k3-1];
			aa  = a[kk_mr-1];
			bb  = b[kk_mr-1];
			a[kk_mr-1] = aa + akp + ajp;
			b[kk_mr-1] = bb + bkp + bjp;
			ak = akp*c72_mr + ajp*c2 + aa;
			bk = bkp*c72_mr + bjp*c2 + bb;
			aj = akm*s72_mr + ajm*s2;
			bj = bkm*s72_mr + bjm*s2;
			a[k1-1] = ak - bj;
			a[k4-1] = ak + bj;
			b[k1-1] = bk + aj;
			b[k4-1] = bk - aj;
			ak = akp*c2 + ajp*c72_mr + aa;
			bk = bkp*c2 + bjp*c72_mr + bb;
			aj = akm*s2 - ajm*s72_mr;
			bj = bkm*s2 - bjm*s72_mr;
			a[k2-1] = ak - bj;
			a[k3-1] = ak + bj;
			b[k2-1] = bk + aj;
			b[k3-1] = bk - aj;
			kk_mr = k4 + kspan;
		} while ( kk_mr < nn_mr);
		kk_mr -= nn_mr;
	} while ( kk_mr <= kspan);
}

void fac_imp(double *a,double *b)
{    

	long k, kspnn, j, k1, k2, jj;
	double ak, bk, aa, bb, aj, bj;
	double c1, s1, c2, s2;
	double ck[23], sk[23];

	k = nfac[i_mr-1];
	kspnn = kspan;
	kspan /= k;
	if (k==3) radix_3(a, b);
	if (k==5) radix_5(a, b);
	if ((k==3) || (k==5)) goto twi;
	if (k!=jf_mr) {
		jf_mr = k;
		s1 = rad_mr/k;
		c1 = cos(s1);
		s1 = sin(s1);
		ck[jf_mr-1] = 1.0;
		sk[jf_mr-1] = 0.0;
		j = 1;
		do {
			ck[j-1] = ck[k-1]*c1 + sk[k-1]*s1;
			sk[j-1] = ck[k-1]*s1 - sk[k-1]*c1;
			k--;
			ck[k-1] =  ck[j-1];
			sk[k-1] = -sk[j-1];
			j++;
	    } while ( j<k);
	}
	do {
		do {
			k1 = kk_mr;
			k2 = kk_mr + kspnn;
			aa = a[kk_mr-1];
			bb = b[kk_mr-1];
			ak = aa;
			bk = bb;
			j  = 1;
			k1 = k1 + kspan;
			do {
				k2 -= kspan;
				j++;
				at_mr[j-1] = a[k1-1] + a[k2-1];
				ak += at_mr[j-1];
				bt_mr[j-1] = b[k1-1] + b[k2-1];
				bk += bt_mr[j-1];
				j++;
				at_mr[j-1]  = a[k1-1] - a[k2-1];
				bt_mr[j-1] = b[k1-1] - b[k2-1];
				k1 += kspan;
			} while ( k1 < k2);
			a[kk_mr-1] = ak;
			b[kk_mr-1] = bk;
			k1 = kk_mr;
			k2 = kk_mr + kspnn;
			j = 1;
			do {
				k1 += kspan;
				k2 -= kspan;
				jj = j; 
				ak = aa;
				bk = bb;
				aj = 0.0;
				bj = 0.0;
				k = 1;
				do {
					k++;
					ak = at_mr[k-1]*ck[jj-1] + ak;
					bk = bt_mr[k-1]*ck[jj-1] + bk;
					k++;
					aj = at_mr[k-1]*sk[jj-1] + aj;
					bj = bt_mr[k-1]*sk[jj-1] + bj;
					jj += j;
					if (jj>jf_mr)  jj-=jf_mr;
				} while ( k<jf_mr);
				k = jf_mr - j;
				a[k1-1] = ak - bj;
				b[k1-1] = bk + aj;
				a[k2-1] = ak + bj;
				b[k2-1] = bk - aj;
				j++;
			} while (j<k);
			kk_mr += kspnn;
		} while (kk_mr <= nn_mr);
		kk_mr -= nn_mr;
	} while ( kk_mr <= kspan);

/***** Multiply by twiddle factors  *****/

twi:
	if (i_mr==m_mr) flag_mr = 1;
	else {
		kk_mr = jc_mr + 1;
		do {
			c2 = 1.0 - cd_mr;
			s1 = sd_mr;
			do {
				c1  = c2;
				s2  = s1;
				kk_mr += kspan;
				do {
					do {
						ak = a[kk_mr-1];
						a[kk_mr-1] = c2*ak - s2*b[kk_mr-1];
						b[kk_mr-1] = s2*ak + c2*b[kk_mr-1];
						kk_mr += kspnn;
					} while ( kk_mr <= nt_mr);
					ak = s1 * s2;
					s2 = s1*c2 + c1*s2;
					c2 = c1*c2 - ak;
					kk_mr = kk_mr - nt_mr + kspan;
				} while ( kk_mr <= kspnn);
				c2 = c1 - (cd_mr*c1 + sd_mr*s1);
				s1 = s1 + (sd_mr*c1 - cd_mr*s1);
				
    /***** Compensate for truncation errors *****/

				c1 = 0.5/(c2*c2 + s1*s1) + 0.5;
				s1 *= c1;
				c2 *= c1;
				kk_mr  = kk_mr - kspnn + jc_mr;
			} while ( kk_mr <= kspan);		  
			kk_mr = kk_mr - kspan + jc_mr + inc_mr;
		} while ( kk_mr <= (jc_mr+jc_mr));	  

	} 
}



void  sing(double *a, double *b,long ntot,long n,long nspan,int isn )
{/* b Arrays that hold the real and imaginary parts */
	if ( n < 2 ) exit(1);
	inc_mr  = isn;
	rad_mr  = TWO_PI;
	s72_mr  = rad_mr / 5.0;
	c72_mr  = cos(s72_mr);
	s72_mr  = sin(s72_mr);
	s120_mr = sqrt(0.75);
	if (isn < 0) { 
		s72_mr  = -s72_mr;
		s120_mr = -s120_mr;
		rad_mr  = -rad_mr;
		inc_mr  = -inc_mr;
	} 
	nt_mr    = inc_mr * ntot;
	ks_mr    = inc_mr * nspan;
	kspan = ks_mr;
	nn_mr    = nt_mr - inc_mr;
	jc_mr    = ks_mr / n;
	radf_mr  = rad_mr * jc_mr * 0.5;
	i_mr     = 0;
	jf_mr    = 0;
	flag_mr  = 0;
	fac_des (n );  
	do   {
		sd_mr = radf_mr / kspan;
		cd_mr = 2.0 * sin(sd_mr) * sin(sd_mr);
		sd_mr = sin(sd_mr+sd_mr);
		kk_mr = 1;
		i_mr  = i_mr + 1;
		if (nfac[i_mr-1]==2)
		  radix_2( a, b);
		if (nfac[i_mr-1]==4) 
			radix_4(isn, a, b); 
		if ( (nfac[i_mr-1]!=2) && (nfac[i_mr-1]!=4)) 
			fac_imp(a, b);	
	 } while ( flag_mr != 1);
	 permute( ntot,  n, a, b);
 } 

/***********************************************************
		2007/11/19@쐬

		1g`̍t[Gϊ
		ASYɊÂ͂邪Cӂ̃f[^TCYɑΉ@
		̈̃f[^xr[0]_ɂȂ悤ɔzu
		g̈̌_xr[0]ɂȂiבւĂȂj

		f[^̓t@Ĉ͎݁@0
		ir=1̂Ƃt[Gϊ@ir=-1̂Ƃt[Gtϊ

		́@xr[],xi[]  o xr[],xi[](̓f[^㏑ďo)
		ir=1̂Ƃt[GϊAir=-1̂Ƃt[Gtϊ
		N ̓f[^

*************************************************************/

void FFT1D(double *xr,double *xi,int ir,int N){
	int i;
	
	if(ir == 1){//t[Gϊ̏ꍇ
		sing(xr, xi, N, N, N, 1);
			for (i=0;i<N;i++) {	
			xr[i]/=N;
			xi[i]/=N;
		}
	}else{//t[Gtϊ̏ꍇ
		sing(xr, xi, N, N, N, -1);
	
	}
}

void FFT2D(double *dimg_r,double *dimg_i,
		   double *xr,double *xi,int ir,int NX,int NY)
{
	/***********************************************************
		2007/11/19@쐬

		摜̃t[Gϊ@@Qt[Gϊ@
	
		͉摜@摜@dimg_r[],@摜dimg_i[]
		
		1FFTւ̓́@xr[],xi[]  @ur[],ui[]͌vZ̈
		ir=1̂Ƃt[GϊAir=-1̂Ƃt[Gtϊ
		N ̓f[^

*************************************************************/
	int i,j;

	//esDFT@
	for(j = 0 ; j < NY ; j++){ 
		for(i = 0 ; i < NX ; i++) {
			xr[i]=dimg_r[j*NX+i];
			xi[i]=dimg_i[j*NX+i];
		}
		FFT1D(xr,xi,ir,NX);//t[Gϊ
//		DFT1D(xr,xi,ur,ui,ir,NX);//t[Gϊ
		for(i = 0 ; i < NX ; i++) {
			dimg_r[j*NX+i]=xr[i];
			dimg_i[j*NX+i]=xi[i];
		}
	}

	//eDFT@
	for(i = 0 ; i < NX ; i++) {
		for(j = 0 ; j < NY ; j++){ 
			xr[j]=dimg_r[j*NX+i];
			xi[j]=dimg_i[j*NX+i];
		}
		FFT1D(xr,xi,ir,NY);//t[Gϊ
	//	DFT1D(xr,xi,ur,ui,ir,NY);//t[Gϊ
		for(j = 0 ; j < NY ; j++){ 
			dimg_r[j*NX+i]=xr[j];
			dimg_i[j*NX+i]=xi[j];
		}
	}


}

void FFT2D(double *dimg_r,double *dimg_i,int ir,int NX,int NY)
{
	/***********************************************************
		2007/11/19@쐬

		摜̃t[Gϊ@@Qt[Gϊ@
	
		͉摜@摜@dimg_r[],@摜dimg_i[]
		
		1FFTւ̓́@xr[],xi[] 
		ir=1̂Ƃt[GϊAir=-1̂Ƃt[Gtϊ
		N ̓f[^

*************************************************************/
	int i,j;

	double *xr;
	double *xi;
	int N;// N = max(NX,NY)

	if(NX>=NY)N = NX;
	else N = NY;

	xr = new double [N];
	xi = new double [N];

	//esDFT@
	for(j = 0 ; j < NY ; j++){ 
		for(i = 0 ; i < NX ; i++) {
			xr[i]=dimg_r[j*NX+i];
			xi[i]=dimg_i[j*NX+i];
		}
		FFT1D(xr,xi,ir,NX);//t[Gϊ
//		DFT1D(xr,xi,ur,ui,ir,NX);//t[Gϊ
		for(i = 0 ; i < NX ; i++) {
			dimg_r[j*NX+i]=xr[i];
			dimg_i[j*NX+i]=xi[i];
		}
	}

	//eDFT@
	for(i = 0 ; i < NX ; i++) {
		for(j = 0 ; j < NY ; j++){ 
			xr[j]=dimg_r[j*NX+i];
			xi[j]=dimg_i[j*NX+i];
		}
		FFT1D(xr,xi,ir,NY);//t[Gϊ
	//	DFT1D(xr,xi,ur,ui,ir,NY);//t[Gϊ
		for(j = 0 ; j < NY ; j++){ 
			dimg_r[j*NX+i]=xr[j];
			dimg_i[j*NX+i]=xi[j];
		}
	}

	delete []xr;
	delete []xi;


}
