//#include "stdafx.h"
#include<windows.h>
#include <stdio.h>
#include <stdlib.h>
//#include <string.h>

#include <math.h>
#include "Palam.h"
#include "Gauss.h"
#include "math_func.h"

#pragma warning(disable:4996)
#define _CRT_SECURE_NO_DEPRECATE 1

GaussFilter1D Gaussfunc1D(double Spread, int FilterSize)
{
	int i;

	GaussFilter1D Filter;
	Filter.Spread=Spread;
	Filter.FilterSize=FilterSize;
	Filter.K=1 / (sqrt((Spread) * PI));
	Filter.data = new double [FilterSize*2+1];

	for(i=-Filter.FilterSize;i<Filter.FilterSize+1;i++){
		Filter.data[i+FilterSize]=Filter.K * exp(-pow((double)i,2.0) / (Filter.Spread));
	}

	return Filter;

}

double* MakeMixtureGauss(MixtureGauss* kernel,int FilterSize)
{
	int i,j;
	double *MixGauss;
	GaussFilter1D Filter;

	MixGauss = new double [FilterSize*2+1];

	
	for(i=-FilterSize;i<FilterSize+1;i++){
		MixGauss[i+FilterSize]=0;
	}

	for(j=0;j<kernel->Num;j++){
		Filter = Gaussfunc1D(kernel->Var[j],FilterSize);

		for(i=-FilterSize;i<FilterSize+1;i++){
			MixGauss[i+FilterSize]+=kernel->Weight[j]*Filter.data[i+FilterSize];
		}

	}

	delete []Filter.data;

	return MixGauss;

}

MixtureGauss ReadMixtureGaussPalam(char *fn_kernel_L,double adjust)
{
	FILE *fp;
	int i;
	char temp[100];

	MixtureGauss kernel_L;

	if ((fp=fopen(fn_kernel_L,"r"))==NULL) {//t@C摜
		fprintf(stderr,"Error: file open [%s].\n",fn_kernel_L);
		getchar();
		exit(1);
	}
	fscanf(fp,"%s",temp);//file nameǂݍ
	printf("%s\t",temp);//file name

	fscanf(fp,"%s",temp);//Numxǂݔ΂

	fscanf(fp,"%s",temp);//̐ǂݍ
	kernel_L.Num=atoi(temp);
	printf("Num=%d\n",kernel_L.Num);//file name

	//zm
	kernel_L.Spread=new double [kernel_L.Num];
	kernel_L.Var=new double [kernel_L.Num];
	kernel_L.Weight=new double [kernel_L.Num];

	fscanf(fp,"%s",temp);//spreadxǂݔ΂
	printf("spread\t");
	for(i=0;i<kernel_L.Num;i++){
		fscanf(fp,"%s",temp);
		kernel_L.Spread[i]=atof(temp);
		printf("%f\t",kernel_L.Spread[i]);
	}
	fscanf(fp,"%s",temp);//weightxǂݔ΂
	printf("\nWeight\t");
	for(i=0;i<kernel_L.Num;i++){
		fscanf(fp,"%s",temp);
		kernel_L.Weight[i]=atof(temp);
		printf("%f\t",kernel_L.Weight[i]);
	}
	
	printf("\nVari\t");
	for(i=0;i<kernel_L.Num;i++){
		kernel_L.Var[i]=pow(kernel_L.Spread[i]/adjust,2);
		printf("%f\t",kernel_L.Var[i]);
	}
	printf("\nAdjust\t%f\n",adjust);

	fclose(fp);

	return kernel_L;

}

MixtureGauss MakeMixtureGauss(char *fn_kernel,double adjust)
{
/**********************************************************************

	fn_kernel : KEXzɕKvȃp[^i[Ăt@C
	adjust : tB^TCY̒W

***********************************************************************/
	int i;
	double MaxSpread=-10000;
	MixtureGauss kernel;
	
	//***   KEX֐ɕKvȃp[^̓ǂݍ݁@***//
	kernel=ReadMixtureGaussPalam(fn_kernel,adjust);
	//***  ő̕UlvZ  ******//
	for(i=0;i<kernel.Num;i++){
		if(kernel.Var[i]>=MaxSpread)MaxSpread=kernel.Var[i];
	}
	printf("Max spread = %f\n",MaxSpread);
	//***  tB^[TCY̌  ******//
	kernel.FilterSize=round(sqrt(4.0*log(2.0)*MaxSpread))-1;//tB^[TCY̌
	printf("FilterSize = %d\n",kernel.FilterSize);
	//***  KEX֐  ******//
	kernel.data=MakeMixtureGauss(&kernel,kernel.FilterSize);//
	//***  f[^̎  ******//
	kernel.N = kernel.FilterSize*2 +1;
	return kernel;

}

