#include <iostream>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <windows.h>
using namespace std;

#include "box_muller_transform.h"

const double PI = 3.141592653589793116;

// ------------------------------------------------------------------------------- //
double NormDistRand::rand(void)
{
	if(!m_flg_n2_cached)
	{
		_box_muller_transform();
		m_flg_n2_cached = true;
		return m_n1 * m_stddev + m_mean;
	}
	else
	{
		m_flg_n2_cached = false;
		return m_n2 * m_stddev + m_mean;
	}
}

// ------------------------------------------------------------------------------- //
void NormDistRand::_box_muller_transform(void)
{
	double alpha = 0.0;
	while(alpha == 0.0)
		alpha = static_cast<double>(std::rand()) / RAND_MAX;
	double beta  = static_cast<double>(std::rand()) / RAND_MAX;
	m_n1 = sqrt(-2 * log(alpha)) * sin(2 * PI * beta);
	m_n2 = sqrt(-2 * log(alpha)) * cos(2 * PI * beta);
	return;
}
